{--------------------------------------------------------}


{
{    Interpretador de script
{
{    Autor: Jos Antonio Borges
{
{    Em 23/06/2000
{
{--------------------------------------------------------}

{------------------------------------------------------------------------------------------}
{
{    Resumo da sintaxe
{
{    Interaes com o usurio
{        escreve [MUDO] ["frase" ou variavel]...  {terminado por & nao pula linha
{        fala ["frase" ou variavel]
{        le [MUDO ou SENHA] [variavel]            {terminado por & l s uma tecla
{        tela [limpa ou minimizada ou normal ou @x,y]
{        bipa [tipoBip]                           { 0 = bip  1 = clek
{        cor ["valor" ou variavel]
{        fundo ["valor" ou variavel]
{        observa TECLADO [variavel]    {0: no foi teclado nada   1: requer leitura
{
{    Menu interativo
{        menu CRIA xmin ymin xmax ymax
{        menu ADICIONA ["valor" ou variavel]
{        menu EXECUTA [variavel] [variavel] [variavel]    { retornados:
{                                        nmero do item, letra teclada e item }
{        menu TERMINA
{
{    Operaes com arquivo
{        abre #n arquivo     {terminado por & arquivo e' criado ou acrescentado se existir
{        fecha #n
{        le #n variavel
{        escreve #n [variavel]                 {terminado por & nao pula linha
{        remove ["nomeArquivo" ou variavel]    {terminado por & no d erro se no apagar
{        renomeia ["nomeArquivo" ou variavel] ["novoNome" ou variavel]
{                                              {terminado por & no d erro se no renomear
{        replica ["nomeArquivo" ou variavel] ["novoNome" ou variavel]
{                                              {terminado por & no d erro se no renomear
{        busca [variavel] [DIR] [["nomeArqs" ou varivel] ou PRXIMO]
{                            { se omitido nome ou PRXIMO devolve diretrio atual
{        dir [CRIA, REMOVE, TROCA] ["nomeDiretorio" ou variavel]
{                                  {terminado por & no d erro
{        checa [variavel]          {resultado da ltima operacao le, escreve
{                                  {0: No houve problemas    > 0: erro
{
{    Operaes com Internet
{        internet [INICIA, TERMINA]
{        conecta #n ["valor" ou variavel] ["porta" ou variavel]
{        serve #n ["porta" ou variavel]
{        observa #n [variavel]    {0: porta no requer ateno   1: requer leitura
{        ip [LOCAL, REMOTO] #n [variavel]
{
{    Processamento de desvios
{        executa ["programa" ou variavel]     {terminado por & nao espera terminar
{        desvia [SCRIPT] [@rotulo ou variavel]
{        chama [@rotulo ou variavel]
{        retorna
{        se [NO] [variavel] [comparador] ["valor" ou variavel] comando
{        cmd [variavel]
{        termina [mudo]
{        debug [-]
{
{    Processamentos de comandos mltiplos e repeties
{        se [NO] [variavel] [comparador] ["valor" ou variavel]
{               seno     opcional
{               fim se        marca o final
{        enquanto [NO] [variavel] [comparador] ["valor" ou variavel]
{               fim enquanto        marca o final
{        repete [variavel] ["valor" ou variavel]
{               fim repete          marca o final
{
{    Processamento de variveis
{        seja [variavel] [ = ] [expresso]
{        ou
{        seja [variavel] [ = ] [funcaoOpcional] [valor ou variavel]...
{                * aps as funes DATA, HORA e DIA no se coloca [valor ou variavel]
{                 opcional usar um sinal de = aps a varivel
{        soma [variavelDest] [valor ou variavel]
{                na soma, eventuais prefixos alfabticos da varivel so mantidos
{        subtrai [variavelDest] [valor ou variavel]
{        multiplica [variavelDest] [valor ou variavel]
{        divide [variavelDest] [valor ou variavel]
{        concatena [variavelDest] [valor ou variavel]
{        copia [variavelDest] [variavel] [caracinicio] [caracfim]
{        transfere [DE, PARA] [variavel]
{        substitui [variavel] [valor antigo] [valor novo]
{        randomiza
{
{    Operaes com janelas
{        espera [tempoEmSegundos]
{        espera [tempo] ["nome janela" ou variavel]
{        janela [FECHA, MINIMIZA, MAXIMIZA, NORMAL] ["nome janela" ou variavel]
{        captura [TTULO ou ATIVA, CAMPO, FOCO] [variavel]
{
{    Aes do teclado e mouse
{        digita "frase" [enter]
{        aciona [tecla virtual]
{        clica [DUPLO, NULO] [onde]
{        le [MOUSE ou RATO] [onde]
{
{    Aes de multimdia
{        toca "frase" ou varivel                 {terminado por & nao espera terminar
{        mci [variavelRetorno] ["frase" ou varivel]
{        imagem "arquivo" x y                     {terminado por & ignora erro
{        sensor [variavel]      {informa o sensor ativo (1..32) da matriz Mapavox}
{
{    Processamento MSAA
{        MSAA captura x y
{        MSAA monitora
{        MSAA fim
{        MSAA checa
{        MSAA nome [variavel]
{        MSAA codigo [variavel]
{        MSAA tipo [variavel]
{        MSAA estado [variavel]
{        MSAA valor [variavel]
{        MSAA area  [variavel x] [variavel y] [variavel larg] [variavel alt]
{
{    Aes de mostrar imagem
{        IMAGEM ""
{        IMAGEM "arq_bmp_ou_jpg" x y   -> se x y omitido, vale (1,1)
{                                      -> se terminado por & ignora erro de arquivo
{
{------------------------------------------------------------------------------------------}
{
{    [valor]     "cadeia de caracteres" ou nmero ou (expresso) ou posio de vetor
{    [expresso] expresso inteira com os operadores (+-*/) e parnteses
{    [funcaoOpcional]    TAMANHO, MAIUSC, RAND, TRIM, POS [variavel ou valor],
{                        DATA, DIA, HORA, TEMPO, PALAVRA
{    [variavel]  letra de a-z (maiusculas = minusculas)
{                ou $ seguido por vrias letras de a-z ou 0-9
{                ou posio de vetor
{    [comparador] '=' '<>' '<' '>' '>=' '<='
{                 '==' '*=*' '=*' '*='
{    [rotulo]  qualquer coisa comeada por '@'
{    [arquivo]  frase ou variavel
{    comentario: linha comeada por *
{    [Onde]
{        x, y
{        tela x, y
{
{------------------------------------------------------------------------------------------}


unit svplus;

interface
uses dvwin, dvcrt, windows, classes, pipe, shellapi,
messages, sysUtils, mmsystem, midi, lista, activex,
{$IFDEF VER150}
dateutils,
{$ENDIF}
dvmacro, dvexec, winsock, dvinet, dvssl, dvmsaa, dvform, dvjpeg, dvhora, dvwav,
mime;

const
SCR_OK = 0;
SCR_ERROEXEC = 1;
SCR_SEMARQUIVO = 2;
SCR_ROTULOINVALIDO = 3;

MAXSCRIPT = 500000;
var
varScript: array ['A'..chr(ord('Z') + 101)] of string;
arqbin: File of Byte;
BinAberto: boolean;
    arqbytes: array [0..134217728] of Byte;
BufRead: array [0..134217728] of Byte;
    bytesgravados: integer;
nomeVarLonga: TStringList;
fimScript, fimScriptMudo: boolean;
type
vetScript = array [1..MAXSCRIPT] of string;

procedure carregaScript (programa: string; tamprog: integer);
procedure mensagem (nomeArq: string; apular: integer);
//procedure trim (var lido: string);
function maiusc (s: string): string;
procedure inicializa(nomeprog: string);
procedure processa;
function cmdScript (lido: string): boolean;
function executaScript (var ultLinhaProc: integer): integer;
procedure zeraVarScript;
function obtemVarLongaScript (nome: string): string;
procedure alteraVarLongaScript (nome, valor: string);
function processaCHR(recebido:string):string;
function getflags():string;

implementation
type
  TSpecials = set of AnsiChar;

const

  SpecialChar: TSpecials =
  ['=', '(', ')', '[', ']', '<', '>', ':', ';', ',', '@', '/', '?', '\',
    '"', '_'];
  NonAsciiChar: TSpecials =
  [Char(0)..Char(31), Char(127)..Char(255)];
  URLFullSpecialChar: TSpecials =
  [';', '/', '?', ':', '@', '=', '&', '#', '+'];
  URLSpecialChar: TSpecials =
  [#$00..#$20, '_', '<', '>', '"', '%', '{', '}', '|', '\', '^', '~', '[', ']',
    '`', #$7F..#$FF];

MAXRETORNO = 20;

const
DEBUG_DESLIGADO  = 'Debug desligado';
DEBUG_LIGADO     = 'Debug ligado';
ERRO_ABRE        = 'Erro na abertura do arquivo';
ERRO_FECHA       = 'Erro no fechamento do arquivo';
ERRO_ARQUIVO     = 'Erro no processamento de arquivo';
ERRO_ESCRITA     = 'Erro na escrita de arquivo';
ERRO_APAGA       = 'Erro no apagamento do arquivo ';
ERRO_DIR         = 'Erro no processamento do diretrio ';
ERRO_CONEXAO     = 'Erro de conexao';
ERRO_PORTA       = 'Erro na porta TCP/IP';
DIVISAO_ZERO     = 'Diviso por zero';
LISTA_JA_EXISTE = 'A lista especificada j existe';
MUITAS_LISTAS = 'Muitas listas no programa (mximo 20)';
STACK_OVERFLOW   = 'Muitas chamadas sem retorno';
STACK_UNDERFLOW  = 'Retorno sem chamada';
COMANDO_INVALIDO = 'Comando invlido: ';

type
TARQ = record
aberto: boolean;
internet: boolean;
soquete: longint;
pbuf: pBufRede;
arq: text;
end;

var
seguro : boolean;
MIDIaberto:boolean;
script: vetScript;
nlinhasScript: integer;
linhaAtual: integer;
topoRetorno: integer;
pilhaRetorno: array [1..MAXRETORNO] of integer;
debug: boolean;
erroProc: boolean;
cmd: string;
varLista: array [0..20] of pListaRec;
arq: text;
statusUltIO: integer;
itemInic: integer;

tempo0: longint;
semana0: word;

arquivo: array ['0'..'9'] of TARQ;

dirInfo: TSearchRec;
atribBusca: word;
sensorAtivo: boolean;
nomeComput, portaComput: string;
porta: word;
cod: integer;

{                 fala uma mensagem
{--------------------------------------------------------}
procedure mensagem (nomeArq: string; apular: integer);
var i: integer;
    s: string;
begin
    if nomeArq = 'SCINIC' then
        s := 'ScriptVox - v'
    else
    if nomeArq = 'SCNOMARQ' then
        s := 'Nome do arquivo .CMD a executar: '
    else
    if nomeArq = 'SCFIM' then
        s := 'Fim do script'
    else
    if nomeArq = 'SCARQNAO' then
        s := 'Arquivo .CMD inexistente'
    else
    if nomeArq = 'SCERREXE' then
        s := 'Erro de execuo na linha '
    else
    if nomeArq = 'SCERRROT' then
        s := 'Este rtulo no existe !'
    else
    if nomeArq = 'SCERRO' then
        s := 'Erro'
    else
    if nomeArq = 'SCEDITE' then
        s := 'Editore e aperte enter'
    else
    if nomeArq = 'SCINTER' then
        s := 'Modo interativo'
    else
        begin
            writeln;
            writeln ('-------------------------------');
            writeln ('--- mensagem errada: ', s, '---');
            writeln ('-------------------------------');
            writeln;
        end;
    write (s);
    for i := 1 to apular do writeln;
    if existeArqSom (nomeArq) then
        sintsom (nomeArq)
    else
        sintetiza (s);
end;

{--------------------------------------------------------}
{      remove brancos ao inicio e fim de uma cadeia
{--------------------------------------------------------}
//procedure trim (var lido: string);
//begin
//    while (lido <> '') and (lido[1] = ' ') do
//        delete (lido, 1, 1);
//    while (lido <> '') and (lido[length(lido)] = ' ') do
//        delete (lido, length(lido), 1);
//end;

{--------------------------------------------------------}
{             transforma cadeia em maiusculos
{--------------------------------------------------------}
function maiusc (s: string): string;
begin
    s := s + #$0;
    ansiUpper (@s[1]);
    delete (s, length (s), 1);
    maiusc := s;
end;

{--------------------------------------------------------}
{                    inicializao
{--------------------------------------------------------}
procedure inicializa(nomeprog : string);
var s: string;
    dirAtual: string;
    p: integer;
label deNovo;
begin
    CoInitialize(NIL);
    sintInic (0, sintAmbiente ('SCRIPVOX', 'DIRSCRIPVOX'));
    clrscr;
    setWindowText (crtWindow, 'SCRIPVOX');
            getDir (0, dirAtual);
            s := sintAmbiente ('SCRIPVOX', 'DIRDEFAULT');
            if s = '' then s := 'c:\winvox\scripts';
            {$I-}  chdir (s);  {$I+}
            if ioresult <> 0 then ;
            chDir (dirAtual);
    s := nomeprog;
    setWindowText (crtWindow, @s[1]);
end;


function calculaExpressao (var s: string; var v: integer): boolean; forward;

var
line: string;
pl, lastpl: integer;

{--------------------------------------------------------}
{             carrega um script na memoria
{--------------------------------------------------------}

procedure carregaScript (programa: string; tamprog: integer);
var
lido: string;
i : integer;
begin
nlinhasscript := tamprog;

script[tamprog] := programa;
end;

{--------------------------------------------------------}
{                 libera a area de script
{--------------------------------------------------------}

procedure liberaScript;
begin
nlinhasScript := 0;
end;

{--------------------------------------------------------}
{             busca um rtulo no arquivo
{--------------------------------------------------------}

function buscaRotulo (rotulo: string): boolean;
var i: integer;
lido: string;
begin
rotulo := maiuscAnsi (rotulo);
for i := 1 to nlinhasScript do
begin
lido := script[i];
if (lido <> '') and (lido[1] = '@') then
begin
if maiuscAnsi (copy (lido, 2, length (lido)-1)) = rotulo then
begin
buscaRotulo := true;
linhaAtual := i;
exit;
end;
end;
end;
buscaRotulo := false;
end;

{--------------------------------------------------------}
{              extrai uma variavel longa do comando
{--------------------------------------------------------}

function extraiVariavelLonga (var lido: string; var v: char): boolean;
var nome: string;
n: integer;
begin
extraiVariavelLonga := false;
delete (lido, 1, 1);
if lido = '' then exit;

while (lido <> '') and (upcase(lido[1]) in ['A'..'Z', '0'..'9', '_']) do
begin
nome := nome + upcase(lido[1]);
delete (lido, 1, 1);
end;

if length (nome) = 0 then exit;

n := nomeVarLonga.indexOf(nome);
if n < 0 then
begin
nomeVarLonga.Add(nome);
n := nomeVarLonga.count-1;
end;

v := chr (n+1 + ord('Z'));
lido := trim (lido);
extraiVariavelLonga := true;
end;

{--------------------------------------------------------}
{              extrai uma variavel do comando
{--------------------------------------------------------}

function extraiVariavel (var lido: string; var v: char): boolean;
begin
extraiVariavel := false;

lido := trim (lido);
if lido = '' then exit;

v := upcase(lido[1]);
if v = '$' then
begin
extraiVariavel := extraiVariavelLonga (lido, v);
exit;
end;

if not (v in ['A'..'Z']) then exit;
delete (lido, 1, 1);

if (lido <> '') and
(upcase (lido[1]) in ['A'..'Z', '0'..'9']) then exit;

lido := trim (lido);
extraiVariavel := true;
end;

{--------------------------------------------------------}
{    transforma o lido num parametro string ou variavel
{--------------------------------------------------------}

function extraiValor (var lido: string; var valor: string): boolean;
var tam: integer;
v: char;
x: integer;
label loopAspas;
begin
extraiValor := false;

lido := trim (lido);
if lido = '' then exit;
valor := '';

if lido[1] in ['0'..'9', '-'] then
begin
repeat
valor := valor + lido[1];
delete (lido, 1, 1);
until (lido = '') or (not (lido[1] in ['0'..'9']));
end
else
if (lido <> '') and (lido[1] = '"') then
begin
valor := '';
loopAspas:
delete (lido, 1, 1);
tam := pos ('"', lido);
if tam = 0 then tam := length (lido)+1;
valor := valor + copy (lido, 1, tam-1);
delete (lido, 1, tam);
if (lido <> '') and (lido[1] = '"') then
begin
valor := valor + '"';
goto loopAspas;
end;
end
else
if (lido <> '') and (lido[1]= '$') then
begin
if not extraiVariavelLonga (lido, v) then exit;
valor := varScript [v];
end
else
if (lido <> '') and (upcase(lido[1]) in ['A'..'Z']) then
begin
valor := varScript [upcase(lido[1])];
delete (lido, 1, 1);
end
else
if (lido <> '') and (lido[1]= '(') then
begin
delete (lido, 1, 1);
if not calculaExpressao (lido, x) then
exit;
valor := intToStr (x);

lido := trim (lido);
if lido[1] <> ')' then exit;
delete (lido, 1, 1);
end
else
exit;   { erro }

lido := trim (lido);
extraiValor := true;
end;

{--------------------------------------------------------}
{         transforma o lido numero de arquivo
{--------------------------------------------------------}

function extraiNumArq (var lido: string; var arqSel: char): boolean;
begin
extraiNumArq := false;

lido := trim (lido);
if lido = '' then exit;
arqSel := ' ';

if lido[1] = '#' then
begin
delete (lido, 1, 1);
if (lido = '') or not (lido[1] in ['0'..'9']) then
exit;
arqSel := lido[1];
delete (lido, 1, 1);
end
else
exit;

if (lido <> '') and (copy (lido, 1, 1) <> ' ') then exit;
while (lido <> '') and (lido[1] = ' ') do delete (lido, 1, 1);
extraiNumArq := true;
end;


{--------------------------------------------------------}
{         transforma o lido em um nome de lista
{--------------------------------------------------------}

function extraiNomeLista (var lido: string; var nome: string): boolean;
var i: string;
begin
extraiNomeLista := false;
lido := trim(lido);
if length(lido) <= 1 then exit;
if not ( lido[1] = '[') then exit;
delete(lido, 1, 1);
i := '';
while true do
begin
i := copy(lido, 1, 1);
delete(lido, 1, 1);
if i = '' then exit;
if (i = ']') and (nome <> '') then
begin
extraiNomeLista := true;
break;
end
else
begin
nome := nome + i;
end;
end;
end;

{converte html para texto}



{--------------------------------------------------------}
{ Comando MIDI
{--------------------------------------------------------}


function processaMIDI(lido:string):boolean;
var
canal,nota,volume,timbre,op:integer;
s,comando:string;
begin
op:=0;
processaMIDI:=false;
lido:=trim(lido);
if lido='' then exit;

lido:=maiuscAnsi(lido);
if (lido='INICIA') and (not MIDIaberto) then begin {inicia processos MIDI}
 phandle:=@handle; InicioMIDI; MIDIaberto:=true;
 processaMIDI:=true; exit; end;

if (lido='TERMINA') and MIDIaberto then begin
 MIDIFim; MIDIaberto:=false;
 processaMIDI:=true; exit; end;

if (lido='PANE') and MIDIaberto then begin
 for canal:=0 to 15 do
  for nota:=0 to 127 do
  NoteOn(canal,nota,0);
 processaMIDI:=true; exit; end;

{so pode processar os demais comandos, se MIDI estiver aberto}
if not MIDIaberto then exit;
comando:=copy(lido,1,2);
delete(lido,1,2);
if lido='' then exit; {precisa de parametros}

if comando='NL' then op:=1 {opo 1=Nota Ligada}
else
if comando='ND' then op:=2 {opo 2=Nota Desligada}
else
if comando='TT' then op:=3 {opo 3=Troca Timbre}
else exit; {por enquanto, s estas trs opes}

{se opo vlida, prossegue}
if not extraiValor(lido,s) then exit; {recebe o primeiro parametro, que  o canal}
canal:=strToInt(s);
if (canal<1) or (canal>16) then exit; {canais, de 1 a 16}
 dec(canal); {internamente, de 0 a 15}
case op of
1:begin
 if not extraiValor(lido,s) then exit;
 nota:=strToInt(s);
 if (nota<0) or (nota>127) then exit;
 if not extraiValor(lido,s) then exit;
 volume:=strToInt(s);
 if (volume<0) or (volume>127) then exit;
if lido<>'' then exit; {nada de abobrinhas no final}
 NoteOn(canal,nota,volume); end;
2:begin
 if not extraiValor(lido,s) then exit;
 nota:=strToInt(s);
 if (nota<0) or (nota>127) then exit;
if lido<>'' then exit; {nada de abobrinhas no final}
 NoteOn(canal,nota,0); end;
3:begin
 if not extraiValor(lido,s) then exit;
 timbre:=strToInt(s);
 if (timbre<0) or (timbre>127) then exit;
if lido<>'' then exit; {nada de abobrinhas no final}
 ProgramChange(canal,timbre); end;
end; {case op of}
processaMIDI:=true;
end; {function processaMIDI}

{--------------------------------------------------------}
{                    Comando Debug
{--------------------------------------------------------}

function processaDebug (lido: string): boolean;
begin
if (lido = '-') or
(copy (lido, 1, 1) = 'N') then
begin
debug := false;
sintWriteln (DEBUG_DESLIGADO);
end
else
begin
debug := true;
sintWriteln (DEBUG_LIGADO);
end;

processaDebug := true;
end;

{--------------------------------------------}
{ Avaliador de expresso aritmtica          }
{ Por Antonio Borges e Bernard Condorcet     }
{ Consultor: Antonio Anibal Teles            }
{ Em maro/2007                              }
{--------------------------------------------}

(*      Sintaxe para a expresso aritmtica LL(1)

<Exp> ::= <Term> <s_Exp>
<s_Exp> ::= + <Exp> | - <Exp> | nil
<Term> ::= <Factor> <op_Term>
<op_Term> ::= * <Term> | / <Term> | nil
<Factor> ::= x | y | ... |  ( <Exp> ) |  - <Factor>
*)


function calculaExpressao (var s: string; var v: integer): boolean;
type
TToken = char;  { + - * / ( ) # NIL }

var
first, follow: TToken;
vfollow: integer;

{-----------------------------------}

function calc_Exp (var v: integer): boolean;   forward;
function calc_Term (var v: integer): boolean;  forward;

{-----------------------------------}

procedure nextToken;
var ss, vv: string;
erro: integer;
begin
first := follow;

vfollow := 0;
while (pl <= length (line)) and (line[pl] = ' ') do
pl := pl + 1;

lastpl := pl;
if pl > length (line) then
follow := #$0
else if line[pl] in ['+', '-', '*', '/', '(', ')'] then
begin
follow := line[pl];
pl := pl + 1;
end
else if line[pl] in ['0'..'9'] then
begin
follow := '#';
repeat
vfollow := (vfollow * 10) + (ord(line[pl]) - ord('0'));
pl := pl + 1;
until (pl > length (line)) or not (line[pl] in ['0'..'9']);
end
else if upcase(line[pl]) in ['A'..'Z', '$'] then
begin
follow := '#';
ss := line[pl];
if line[pl] = '$' then
begin   // variveis longas
while true do
begin
pl := pl + 1;
if (pl <= length (line)) and
(upcase(line[pl]) in ['A'..'Z', '0'..'9']) then
ss := ss + line [pl]
else
break;
end;
pl := pl - 1;
end;

if not extraiValor (ss, vv) then
follow := '?'
else
begin
val (vv, vfollow, erro);
if erro <> 0 then
begin
follow := '?';
vfollow := 0;
end
else
pl := pl + 1;
end;
end
else
begin
follow := '?';
pl := pl + 1;
end;
end;

{-----------------------------------}

function calc_factor (var v: integer): boolean;
var op: TToken;
begin
calc_factor := false;
v := 0;
op := follow;

case op of
'#': begin
v := vfollow;
nextToken;
calc_factor := true;
end;

'-': begin
nextToken;
if calc_factor (v) then
begin
v := -v;
calc_factor := true;
end;
end;

'(': begin
nextToken;
if calc_exp (v) then
if follow = ')' then
begin
calc_factor := true;
nextToken;
end;
end;
end;
end;

{-----------------------------------}

function calc_Term (var v: integer): boolean;
var v1, v2: integer;
op: char;
begin
calc_Term := false;
if calc_factor (v1) then
begin
calc_Term := true;
op := follow;
v := v1;
while (op = '*') or (op = '/') do
begin
nextToken;
if calc_factor (v2) then
begin
case op of
'*': v := v1 * v2;
'/': v := v1 div v2;
end;
end
else
if (follow = '*') or (follow = '/') then  // evita ** e outros
begin
calc_Term := false;
exit;
end;
op := follow;
v1 := v;
end;
end;
end;

{-----------------------------------}

function calc_Exp (var v: integer): boolean;
var v1, v2: integer;
op: char;
begin
calc_Exp := false;
if calc_term (v1) then
begin
calc_Exp := true;
op := follow;
v := v1;
while (op = '+') or (op = '-') do
begin
nextToken;
if calc_term (v2) then
begin
case op of
'+': v := v1 + v2;
'-': v := v1 - v2;
end;
end
else
if (follow = '-') or (follow = '-') then  // evita ++. -- e outros
begin
calc_Exp := false;
exit;
end;
op := follow;
v1 := v;
end;
end;
end;

{-----------------------------------}

var ok: boolean;
begin
line := s;
pl := 1;
lastpl := pl;
nextToken;
v := 0;
ok := calc_Exp (v); {and (follow = #$0)}
s := copy (s, lastpl, 9999);
calculaExpressao := ok;
end;

{--------------------------------------------------------}
{                   comando seja
{--------------------------------------------------------}

function processaRandomiza (lido: string): boolean;
begin
processaRandomiza := false;
if lido <> '' then exit;

randomize;
processaRandomiza := true;
end;

{--------------------------------------------------------}
{                   comando seja
{--------------------------------------------------------}

function processaSeja (lido: string): boolean;
var v: char;
i, p, nc: integer;
r: longint;
erro: integer;
s, fun, valor, busc: string;
ano, mes, dia, semana: word;
hora, minuto, segundo, cent: word;
ndias: integer;
tempo: longint;
{$IFDEF VER150}
date_and_time: TDateTime;
{$ENDIF}

const
tabSemana: array [0..6] of string[9] =
('Domingo', 'Segunda', 'Tera', 'Quarta', 'Quinta', 'Sexta', 'Sbado');
begin
processaSeja := false;
if not extraiVariavel (lido, v) then exit;
if lido = '' then exit;

if lido[1] = '=' then    {sinal de igual  opcional }
begin
delete (lido, 1, 1);
lido := trim (lido);
end;

if lido = '' then exit;

{funo params, passa os argumentos da linha de comando para o script.}
if maiuscAnsi (lido) = 'PARAMS' then begin
 if ParamCount>=1 then
 str((ParamCount),s)
 else
 s:='0';
 for i:=1 to ParamCount do begin {concatena os parametros}
 s:=s+' ';
 s:=s+ParamStr(i);
 end; {concatena os parametros}
varScript[v]:=s;
processaSeja:=true;
exit;
end; {funo params}

if maiuscAnsi (lido) = 'DATA' then
begin
{$IFDEF VER150}
date_and_time := now;
decodeDate (date_and_time, ano, mes, dia);
{$ELSE}
getDate(ano, mes, dia, semana);
{$ENDIF}
str (dia, s);
if length (s) = 1 then s := '0' + s;
valor := s;
str (mes, s);
if length (s) = 1 then s := '0' + s;
valor := valor + '/' + s;
str (ano, s);
if length (s) = 1 then s := '0' + s;
valor := valor + '/' + s;
varScript[v] := valor;
processaSeja := true;
exit;
end;
if maiuscAnsi (lido) = 'CRLF' then
begin
varscript[v] := #$0D + #$0A;
processaseja := true;
exit;
end;

if maiuscAnsi (lido) = 'HORA' then
begin
{$IFDEF VER150}
date_and_time := now;
decodeTime (date_and_time, hora, minuto, segundo, cent);
{$ELSE}
gettime (hora, minuto, segundo, cent);
{$ENDIF}
str (hora, s);
if length (s) = 1 then s := '0' + s;
valor := s;
str (minuto, s);
if length (s) = 1 then s := '0' + s;
valor := valor + ':' + s;
str (segundo, s);
if length (s) = 1 then s := '0' + s;
valor := valor + ':' + s;
varScript[v] := valor;
processaSeja := true;
exit;
end;

if maiuscAnsi (lido) = 'DIA' then
begin
{$IFDEF VER150}
date_and_time := now;
semana := dayOfTheWeek (date_and_time);
{$ELSE}
getDate(ano, mes, dia, semana);
{$ENDIF}

varScript[v] := tabSemana[semana];
processaSeja := true;
exit;
end;

if maiuscAnsi (lido) = 'TEMPO' then
begin
{$IFDEF VER150}
date_and_time := now;
decodeDate (date_and_time, ano, mes, dia);
semana := dayOfTheWeek (date_and_time);
decodeTime (date_and_time, hora, minuto, segundo, cent);
{$ELSE}
getDate(ano, mes, dia, semana);
gettime (hora, minuto, segundo, cent);
{$ENDIF}

ndias := semana - semana0;
if ndias < 0 then ndias := ndias + 7;
hora := hora + ndias*24;

tempo := ((hora*60+minuto)*60+segundo)*100+cent;
tempo := tempo - tempo0;

str (tempo, varScript[v]);
processaSeja := true;
exit;
end;

nc := 0;
if maiuscAnsi (copy (lido, 1, 8)) = 'TAMANHO ' then nc := 8
else
if maiuscAnsi (copy (lido, 1, 7)) = 'MAIUSC ' then nc := 7
else
if maiuscAnsi (copy (lido, 1, 5)) = 'TRIM ' then nc := 5
else
if maiuscAnsi (copy (lido, 1, 4)) = 'POS ' then nc := 4
else
if maiuscAnsi (copy (lido, 1, 5)) = 'RAND ' then nc := 5
else
if maiuscAnsi (copy (lido, 1, 8)) = 'PALAVRA ' then nc := 8
else
if maiuscAnsi(copy(lido,1,4))='CHR ' then nc:=4
else
if maiuscAnsi(copy(lido,1,4))='ASC ' then nc:=4;

if nc <> 0 then
begin
fun := maiuscAnsi (copy (lido, 1, nc-1));
delete (lido, 1, nc);
lido := trim (lido);

if (fun = 'POS') or (fun = 'PALAVRA') then
if not extraiValor (lido, busc) then exit;

if not extraiValor (lido, valor) then exit;
if lido <> '' then exit;
if fun='ASC' then
if (length(valor)<>1) then varScript[v]:='' else begin
str(ord(valor[1]),valor);
varScript[v]:='#'+valor;
end
else
if fun='CHR' then
varScript[v]:=processaCHR(valor)
else
if fun = 'TAMANHO' then
str (length(valor), varScript[v])
else
if fun = 'MAIUSC' then
varScript[v] := maiuscAnsi (valor)
else
if fun = 'TRIM' then
begin
valor := trim (valor);
varScript[v] := valor;
end
else
if fun = 'POS' then
str (pos (busc, valor), varScript[v])
else
if fun = 'RAND' then
begin
val (valor, r, erro);
if erro <> 0 then exit;
str (random (r), varScript[v])
end
else
if fun = 'PALAVRA' then
begin
val (busc, r, erro);
if erro <> 0 then exit;
if r < 1 then exit;
for i := 1 to r-1 do
begin
p := pos (' ', valor);
if p <> 0 then
begin
delete (valor, 1, p);
valor := trim (valor);
end
else
valor := '';
end;

p := pos (' ', valor);
if p <> 0 then delete (valor, p, 999);
varScript[v] := valor;
end
end
else
begin
if lido[1] = '"' then
begin
if not extraiValor (lido, valor) then exit;
varScript[v] :=  valor;
end
else
begin
if not extraiValor(lido, valor) then exit;
varScript[v] := valor;
end
end;

if trim (lido) = '' then processaSeja := true;
end;

function processaCHR(recebido:string):string;
var
r,erro:integer;
begin
if (length(recebido)>4) and (recebido[4]='#') then begin {,fr um cdigo retornado por l tecla}
for r:=1 to 3 do
if (pos(recebido[r],'01')=0) then begin processaCHR:=''; exit; end; {,s pode ser 0 ou 1}
recebido:=copy(recebido,4,length(recebido)); {,retira as flags iniciais}
end {se for cdigo retornado por l tecla}
else
if recebido[1]<>'#' then begin processaCHR:=''; exit; end; {tem que comear com cardinal}
delete(recebido,1,1); {elimina o cardinal}
if recebido[1]='0' then begin processaCHR:=''; exit; end; {no pode comear com 0}
val(recebido,r,erro);
if erro<>0 then begin processaCHR:=''; exit; end; {no pde converter}
processaCHR:=chr(r);
end; {function processaCHR}

{--------------------------------------------------------}
{                   comando soma
{--------------------------------------------------------}

function processaSoma (lido: string): boolean;
var v: char;
s, norig: string;
n, o: longint;
erro: integer;
valor: string;
begin
processaSoma := false;

if not extraiVariavel (lido, v) then exit;
if lido = '' then exit;

if not extraiValor (lido, valor) then exit;
val (valor, n, erro);
if erro <> 0 then exit;

norig := '';
s := varScript[v];
while (s <> '') and (s[length (s)] in ['0'..'9']) do
begin
norig := s[length(s)] + norig;
delete (s, length(s), 1);
end;
if (s <> '') and (s[length (s)] = '-') then
begin
norig := s[length(s)] + norig;
delete (s, length(s), 1);
end;
val (norig, o, erro);

str (o+n, norig);
varScript[v] := s + norig;

processaSoma := true;
end;

{--------------------------------------------------------}
{           comandos subtrai, multiplica, divide
{--------------------------------------------------------}

function processaContas (lido: string; operador: char): boolean;
var v: char;
norig: string;
n, o: longint;
erro: integer;
valor: string;
begin
processaContas := false;

if not extraiVariavel (lido, v) then exit;
if lido = '' then exit;

val (varScript[v], o, erro);
if erro <> 0 then exit;

if not extraiValor (lido, valor) then exit;
val (valor, n, erro);
if erro <> 0 then exit;

case operador of
'+':  str (o+n, norig);
'-':  str (o-n, norig);
'*':  str (o*n, norig);
'/':  begin
if n = 0 then
begin
sintWriteln (DIVISAO_ZERO);  {'Diviso por zero'}
exit;
end;
str (o div n, norig);
end;
end;

varScript[v] := norig;

if lido <> '' then exit;
processaContas := true;
end;

{--------------------------------------------------------}
{                   comando concatena
{--------------------------------------------------------}

function processaConcatena (lido: string): boolean;
var v: char;
valor: string;
begin
processaConcatena := false;

if not extraiVariavel (lido, v) then exit;
if not extraiValor (lido, valor) then exit;
if lido <> '' then exit;

varScript[v] := varScript[v] + valor;

processaConcatena := true;
end;

{--------------------------------------------------------}
{                  comando copia
{--------------------------------------------------------}

function processaCopia (lido: string): boolean;
var vdest, vorig: char;
c1, c2: string;
i1, i2, erro: integer;
begin
processaCopia := false;
if not extraiVariavel (lido, vdest) then exit;
if not extraiVariavel (lido, vorig) then exit;

if not extraiValor (lido, c1) then exit;
if not extraiValor (lido, c2) then exit;
c1 := trim(c1);
c2 := trim(c2);

val (c1, i1, erro);
if erro <> 0 then exit;
val (c2, i2, erro);
if erro <> 0 then exit;

varScript[vdest] := copy (varScript[vorig], i1, (i2-i1+1));
processaCopia := true;
end;

{--------------------------------------------------------}
{                  comando deleta
{--------------------------------------------------------}

function processaDeleta (lido: string): boolean;
var vorig: char; txt: string;
c1, c2: string;
i1, i2, erro: integer;
begin
processaDeleta := false;
if not extraiVariavel (lido, vorig) then exit;
if not extraiValor (lido, c1) then exit;
if not extraiValor (lido, c2) then exit;
c1 := trim(c1);
c2 := trim(c2);

val (c1, i1, erro);
if erro <> 0 then exit;
val (c2, i2, erro);
if erro <> 0 then exit;
txt := varScript[vorig];
delete(txt, i1, i2);
varScript[vorig] := txt;
processaDeleta := true;
end;

{--------------------------------------------------------}
{                  comando substitui
{--------------------------------------------------------}

function processaSubstitui (lido: string): boolean;
var vorig: string;
v: char;
c1, c2: string;
i: integer;
begin
processaSubstitui := false;
if not extraiVariavel (lido, v) then exit;
if not extraiValor (lido, c1) then exit;
if not extraiValor (lido, c2) then exit;

vorig := varScript[v];
for i := length(vorig)-length(c1)+1 downto 1 do
if copy(vorig, i, length(c1)) = c1 then
begin
delete (vorig, i, length(c1));
insert (c2, vorig, i);
end;

varScript[v] := vorig;
processaSubstitui := true;
end;

{--------------------------------------------------------}
{                  comando toca
{--------------------------------------------------------}

function processaToca (lido: string): boolean;
var
retornoMci: array [0..255] of char;
ficaTocando: boolean;
nomeArq: string;

procedure sendString (s: string);
var p: array [0..255] of char;
begin
strPcopy (p, s);
mciSendString (p, retornoMci, 255, 0);
end;

procedure toca (nomeArq: string; ficaTocando: boolean);
begin
if ficaTocando then
sendString ('play ' + nomeArq)
else
begin
sendString ('open "' + nomearq + '" alias myfile');
sendString ('play myfile');
repeat
delay (100);
sendString ('status myfile mode');
until keypressed or (strPas (retornoMci) <> 'playing');
while keypressed do readkey;

sendString ('stop myfile');
sendString ('close myfile');
end;
end;

begin
processaToca := false;
ficaTocando := false;
if (lido <> '') and (lido[length(lido)] = '&') then
begin
ficaTocando := true;
delete (lido, length (lido), 1);
lido := trim (lido);
end;

if not extraiValor (lido, nomeArq) then exit;
if lido <> '' then exit;

toca (nomeArq, ficaTocando);
processaToca := true;
end;

{--------------------------------------------------------}
{                  comando mci
{--------------------------------------------------------}

function processaMci (lido: string): boolean;
var
cmd: string;
retornoMci: array [0..255] of char;
v: char;

procedure sendString (s: string);
var p: array [0..255] of char;
begin
strPcopy (p, s);
mciSendString (p, retornoMci, 255, 0);
end;

begin
processaMci := false;

if not extraiVariavel (lido, v) then exit;
if not extraiValor (lido, cmd) then exit;
if lido <> '' then exit;

sendString (cmd);
varScript[v] := strPas (retornoMci);
processaMci := true;
end;

{--------------------------------------------------------}
{                  comando abre
{--------------------------------------------------------}

function processaAbre (lido: string): boolean;
var arqSel: char;
adiciona: boolean;
nomeArq: string;

label erro;
begin
processaAbre := true;
adiciona := false;
nomeArq := '';

if (lido <> '') and (lido [length(lido)] = '&') then
begin
adiciona := true;
delete (lido, length(lido), 1);
lido := trim (lido);
end;

if not extraiNumArq (lido, arqSel) then goto erro;

if lido = '' then goto erro;

if not extraiValor (lido, nomeArq) then goto erro;
if nomeArq = '' then goto erro;

with arquivo [arqsel] do
begin
assign (arq, nomeArq);
{$I-}
if adiciona then
begin
append (arq);
if ioresult <> 0 then rewrite (arq);
end
else
reset (arq);
if ioresult <> 0 then goto erro;
{$I+}

aberto := true;
internet := false;
end;

exit;

erro:
sintWriteln (ERRO_ABRE + ' ' + nomearq);  {'Erro na abertura do arquivo'}
processaAbre := false;
end;

{--------------------------------------------------------}
{                  comando Internet
{--------------------------------------------------------}

function processaInternet (lido: string): boolean;
begin
processaInternet := true;
if maiuscAnsi (lido) = 'INICIA' then
abreWinSock
else
if maiuscAnsi (lido) = 'TERMINA' then
fechaWinSock
else
processaInternet := false;
end;
{--------------------------------------------------------}
{                  comando Conecta
{--------------------------------------------------------}

function processaConecta (lido: string): boolean;
var arqSel: char;
ignoraErro: boolean;
label erro, erro2;
begin
processaConecta := true;
    if maiuscansi(copy(lido,1,4)) = 'SSL ' then
begin
 seguro := true;
            delete (lido, 1, 4);
end;

ignoraErro := false;
if (copy(lido, length(lido), 1) = '&') then
begin
delete(lido, length(lido), 1);
ignoraErro := true;
end;

if not extraiNumArq (lido, arqSel) then goto erro;

if lido = '' then goto erro;

if not extraiValor (lido, nomeComput) then goto erro;
if not extraiValor (lido, portaComput) then goto erro;

val (portaComput, porta, cod);
if cod <> 0 then goto erro2;

with arquivo [arqSel] do
begin
    if not seguro then
            soquete := abreConexao (nomeComput, porta)
    else
            soquete := abreConexaossl (nomeComput, porta);

if soquete < 0 then goto erro;

pBuf := inicBufRede (soquete);
internet := true;
aberto := true;
end;
if ignoraErro then statusULTIO := 0;
exit;

erro:
if not ignoraErro then
begin
sintWriteln (ERRO_CONEXAO);  {'Erro de conexao'}
processaConecta := false;
exit;
end
else
begin
statusUltIO := 1;
exit;
end;

erro2:
if not ignoraErro then
begin
sintWriteln (ERRO_PORTA);  {'Erro na porta TCP/IP'}
processaConecta := false;
end
else
begin
processaConecta := true;
statusUltIO := 2;
end;
end;

{comando ativassl}
function processaativassl (lido : string): boolean;
var arqsel : char;
begin
    processaativassl := false;
if not extraiNumArq (lido, arqSel) then exit;

with arquivo [arqSel] do
begin
            soquete := abreConexaossl (nomeComput, porta);
//sslativado := true;
end;
    processaativassl := true;
end;

{--------------------------------------------------------}
{                  comando Serve
{--------------------------------------------------------}

function processaServe (lido: string): boolean;
var arqSel: char;
portaComput: string;
porta: word;
soq: longint;
cod: integer;
label erro, erro2;
begin
processaServe := true;

if not extraiNumArq (lido, arqSel) then goto erro;

if lido = '' then goto erro;
if not extraiValor (lido, portaComput) then goto erro;
val (portaComput, porta, cod);
if cod <> 0 then goto erro2;

with arquivo [arqSel] do
begin
soq := escutaConexao (porta);
if soq < 0 then goto erro;
soquete := aceitaConexao (soq);
fechaConexao (soq);
if soquete < 0 then goto erro;

pBuf := inicBufRede (soquete);
internet := true;
aberto := true;
end;
exit;

erro:
sintWriteln (ERRO_CONEXAO);  {'Erro de conexao'}
processaServe := false;
exit;

erro2:
sintWriteln (ERRO_PORTA);  {'Erro na porta TCP/IP'}
processaServe := false;
end;

{--------------------------------------------------------}
{                  comando observa
{--------------------------------------------------------}

function processaObserva (lido: string): boolean;
var arqSel: char;
v: char;
teclado: boolean;
begin
processaObserva := false;
teclado := false;
if maiuscAnsi (copy (lido, 1, 8)) = 'TECLADO ' then
begin
teclado := true;
delete (lido, 1, 8);
end
else
if not extraiNumArq (lido, arqSel) then exit;

lido := trim (lido);
if not extraiVariavel (lido, v) then exit;
if lido <> '' then exit;

if teclado then
varScript[v] := chr (ord (keypressed) + ord ('0'))
else
with arquivo [arqsel] do
begin
if (not aberto) or (not internet) then
varScript[v] := '0'
else
str (integer(temDadoBufRede (pbuf)), varScript[v]);
end;

processaObserva := true;
end;

{--------------------------------------------------------}
{                  comando Checa
{--------------------------------------------------------}

function processaCheca (lido: string): boolean;
var
v: char;
begin
processaCheca := false;
if not extraiVariavel (lido, v) then exit;
if lido <> '' then exit;

str (statusUltIO, varScript[v]);
processaCheca := true;
end;

{--------------------------------------------------------}
{                  comando Fecha
{--------------------------------------------------------}

function processaFecha (lido: string): boolean;
var arqSel: char;
label erro;
begin
if not extraiNumArq (lido, arqSel) then goto erro;

with arquivo [arqsel] do
begin
{$I-}
if aberto then
if internet then
begin
fimBufRede (pbuf);
fechaConexao (soquete);
seguro := false;
end
else
close (arq);
{$I+}
aberto := false;
end;

if ioresult <> 0 then goto erro;

processaFecha := true;
exit;

erro:
sintWriteln (ERRO_FECHA);  {'Erro no fechamento do arquivo'}
processaFecha := false;
end;

{--------------------------------------------------------}
{                  comando soletra
{--------------------------------------------------------}

function processaSoletra(lido: string) :boolean;
var v: string;
begin
processaSoletra := false;
if lido = '' then exit;
extraiValor(lido, v);
sintSoletra (v);
write(v);
while sintFalando do waitMessage;
processaSoletra := true;
end;

{--------------------------------------------------------}
{                  comando titulo
{--------------------------------------------------------}

function processaTitulo(lido: string): boolean;
var v: array[0..300] of char; tit: string;
begin
processaTitulo := false;
if lido = '' then exit;
extraiValor(lido, tit);
strPCopy(v, tit);
setWindowText (crtWindow, v);
processaTitulo := true;
end;

{Funo auxiliar: remove especificaes quotedprintable}
function convQuotedPrintable (s: string): string;
var i: integer;
    sai: string;

    function conv16 (c: char): integer;
    begin
        if c in ['0'..'9'] then  conv16 := ord (c) - ord ('0')
        else
        if c in ['A'..'F'] then  conv16 := ord (c) - ord ('A') + 10
        else
        if c in ['a'..'f'] then  conv16 := ord (c) - ord ('a') + 10
        else
            conv16 := 0;
    end;

    function eHexa (c: char): boolean;
    begin
        eHexa := c in ['0'..'9', 'a'..'f', 'A'..'F'];
    end;

begin
    sai := '';
    i := 1;
    if (s <> '') and (s[length(s)] = '=') then
        delete (s, length (s), 1);

    while i <= length (s) do
        begin
            if (i <= length(s)-2) and
               (s[i] = '=') and eHexa(s[i+1]) and eHexa(s[i+2]) then
                begin
                    sai := sai + chr ((conv16 (s[i+1]) shl 4) + conv16 (s[i+2]));
                    i := i + 3;
                end
            else
                begin
                    sai := sai + s[i];
                    i := i + 1;
                end;
        end;

    convQuotedPrintable := sai;
end;

{funo auxiliar: encodequotedprintable - adiciona especificaes quoted printable.
Retirada da unit synacode, da biblioteca synapse.}

function EncodeQuotedPrintable(const Value: AnsiString): AnsiString;

function EncodeTriplet(const Value: AnsiString; Delimiter: AnsiChar;
  Specials: TSpecials): AnsiString;
var
  n, l: Integer;
  s: AnsiString;
  c: AnsiChar;
begin
  SetLength(Result, Length(Value) * 3);
  l := 1;
  for n := 1 to Length(Value) do
  begin
    c := Value[n];
    if c in Specials then
    begin
      Result[l] := Delimiter;
      Inc(l);
      s := IntToHex(Ord(c), 2);
      Result[l] := s[1];
      Inc(l);
      Result[l] := s[2];
      Inc(l);
    end
    else
    begin
      Result[l] := c;
      Inc(l);
    end;
  end;
  Dec(l);
  SetLength(Result, l);
end;

begin
  Result := EncodeTriplet(Value, '=',  ['='] + NonAsciiChar);
end;





{funo auxiliar, download}

{funo auxiliar, download}

function download(link, nomeArq: string; comclek : boolean; cookies : string) : boolean;


procedure trazhtml(link, nomeArq: string; comclek : boolean; cookies : string);
var buf : pbufrede;
sock : integer;
s : string;
arq : text;
host: string;
comssl : boolean;
i, j : integer;
porta : string;

Begin
if uppercase(copy (link,1,5)) = 'HTTPS' then comssl := true
else
comssl := false;
    if (link = '') or (nomearq = '') then exit;
assignfile(arq,nomearq);
    link := copy (link, pos('://', link)+3, 999);
    i := pos (':', link);
if i <> 0 then begin
i := i + 1;
j := length(link);
porta := copy (link, i,j-i+1);
i := pos('/',porta);
if i <> 0 then
porta := copy (porta, 1,i-1);
link := stringreplace(link,':'+porta,'',[rfreplaceall]);
end;

    i := pos ('/', link);
if i = 0 then begin
    host := link;
link := '/';
host := copy (link, 1, i-1);
end
else
begin
    host := copy (link, 1, i-1);
    delete (link, 1, i-1);
end;

comclek := false;
abrewinsock;
if (porta = '') and (not comssl) then
porta := '80'
else
if (porta = '') and (comssl) then
porta := '443';
sock := abreconexao (host,strtoint(porta));
buf := inicbufrede(sock);
writelnrede(sock,'GET '+link+' HTTP/1.1');
writelnrede(sock,'Host: '+host);
writelnrede(sock,'User-Agent: dosvox');
writelnrede(sock,'Connection: close');
writelnrede(sock,'Accept-Language: pt-br');
writelnrede(sock,'UA-CPU: x86');
if cookies <> '' then
    writelnRede(sock,'Cookie: '+cookies);
writelnrede(sock,'');

repeat
readlnbufrede(buf,s,0);
until (s = '');

rewrite(arq);
while (readlnbufrede(buf,s,0)) do writeln(arq,s);
 writeln(arq,s);
fechaconexao(sock);
fechawinsock;
fimbufrede(buf);
closefile(arq);
end;
{
function obtemtaxatransf(rtaxatransf : extended; ccc, ccc2 : word) : string;
var s : string;
begin
if ccc2 < ccc then ccc2 := ccc2 + 100;
if ccc2 = ccc then exit;
ccc2 := ccc2-ccc;
rtaxatransf := rtaxatransf / 1024.0;
rtaxatransf := (100*rtaxatransf / ccc2)*8;
if rtaxatransf >= 1024 then
begin
rtaxatransf := rtaxatransf / 1024.0;
s := floattostrf(rtaxatransf,ffgeneral,5,2) + 'Mb/s';
end
else
s := floattostrf(rtaxatransf,ffgeneral,5,2) + 'Kb/s';
if pos ('E',s) > 0 then
s := copy(s,1,pos('E',s)-1);
obtemtaxatransf := s;
end;
}
const
    UM_K = 1024;
um_m = 1024*1024;
um_g= 1024*1024*1024;
erro_400= 'Erro http400:Requisio http no foi bem formulada.';
    Erro_404 ='Erro http404: Pgina no encontrada.';
dl_resumido='Retomando download';
bytesaler = 51200;
var
    sock : integer;
    buflocal : array[1..bytesaler] of char;
    buf : pbufrede;
    host : string;
original : string;
    arq : file;
escritos, areceber, tamanho : int64;
recebidos : extended;
srecebidos : string;
porcentagem : extended;
sporcentagem : string;
aler, transferidos : integer;
    s: string;
    i, j: longint;
    c, c2 : char;
jagravados : int64;
    status: string;
comssl : boolean;
porta : string;
tipo : string;
gravandoaudio : boolean;
hh, mm, ss, ccc, ccc2: word;
rtaxatransf : extended;
taxatransf : string;
label montacabec, fim;

begin
original := link;
    download := false;
    jagravados := 0;

    if (link = '') or (nomearq = '') then exit;
assignfile(arq,nomearq);
montaCabec:
if uppercase(copy (link,1,5)) = 'HTTPS' then comssl := true
else
comssl := false;

    link := copy (link, pos('://', link)+3, 999);
    i := pos (':', link);
if i <> 0 then begin
i := i + 1;
j := length(link);
porta := copy (link, i,j-i+1);
i := pos('/',porta);
if i <> 0 then
porta := copy (porta, 1,i-1);
link := stringreplace(link,':'+porta,'',[rfreplaceall]);
end;

    i := pos ('/', link);
if i = 0 then begin
    host := link;
link := '/';
end
else
begin
    host := copy (link, 1, i-1);
    delete (link, 1, i-1);
end;
    abreWinsock;
if (porta = '') and (not comssl) then
porta := '80'
else
if (porta = '') and (comssl) then
porta := '443';
if comssl then
sock := abreconexaossl (host,strtoint(porta))
else
sock := abreconexao (host,strtoint(porta));

    writelnRede(sock,'GET '+ link +' HTTP/1.1');
writelnrede(sock,'User-Agent: scripvox+ V5.x');
writelnrede(sock,'Accept: */*');
    writelnRede(sock,'Host: '+host);
writelnrede(sock,'Connection: close');
    if fileexists (nomearq) then
begin
filemode := 2;
reset(arq,1);
        jagravados :=int64( filesize(arq));
if jagravados < 0 then jagravados := jagravados*-1;
    Writelnrede (sock,'Range: bytes='+inttostr(jagravados)+'-');
end;
if cookies <> '' then
    writelnRede(sock,'Cookie: '+cookies);
    writelnRede(sock,'');

    buf := inicBufRede(sock);
    readlnBufRede(buf, s,0);
    status := copy (s, pos(' ', s) + 1, 3);
    case strtoint(status) of
    400: begin
    sintwriteln(erro_400);
    exit;
    end;
    404: begin
    sintwriteln(erro_404);
    exit;
    end;
    206: sintwriteln(dl_resumido);
    200: begin
rewrite(arq,1);
end;
end;

    tamanho := 0;
    repeat
        readlnBufRede(buf, s, 0);
        if copy(s, 1, 8) = 'Location' then
            begin
                link :=  copy(s, 11, length(s));
                fimBufRede(buf);
                fechaConexao(sock);
                fechaWinsock;
original := link;
                goto montaCabec;
            end;
        if uppercase (copy(s, 1, 12)) = 'CONTENT-TYPE' then
tipo := trim(copy(s, 14, length(s)));

        if uppercase (copy(s, 1, 14)) = 'CONTENT-LENGTH' then begin
s := copy(s, 16,999999);
            tamanho := strtoint64(s);
end;
    until s = '';

    if jagravados > 0 then seek(arq,jagravados);

    if jagravados > 0 then
begin
 escritos := jagravados;
    areceber := areceber - jagravados;
    transferidos := jagravados;
end
    else
    escritos := 0;
if (tamanho = 0) and (maiuscansi(copy(tipo,1,5)) <> 'AUDIO')then
begin
    closefile(arq);
    fechaconexao(sock);
    fechawinsock;
    fimbufrede(buf);
trazhtml(original, nomeArq, comclek,cookies);
download := true;
exit;
end;
if tamanho = 0 then begin
 tamanho := 999999999;
gravandoaudio := true;
end;
    aReceber := tamanho;
    while (aReceber >= 1) or (true)do
        begin
if areceber >= bytesaler then
aler := bytesaler
else
                aLer := aReceber;

//gettime (hh,mm,ss,ccc);
            for i := 1 to aler do
if not                 lecaracbufrede(buf,buflocal[i]) then goto fim;
//gettime (hh,mm,ss,ccc2);
            blockwrite(arq, buflocal, aLer, transferidos);
if transferidos = 0 then goto fim;
if not gravandoaudio then             aReceber := aReceber - aler;
//rtaxatransf := transferidos;
if comclek then sintclek;
//taxatransf := obtemtaxatransf(rtaxatransf,ccc,ccc2);

if keypressed then
                begin
                    c := readkey;
                    if c = #13 then
                        Begin
            escritos := int64(filesize(arq));
recebidos := int64(filesize(arq));
if recebidos <0 then recebidos := recebidos *-1;
if gravandoaudio then
sintetiza(inttostr(filesize(arq))+' bytes escritos em disco.')
else
begin
sintetiza('Recebidos: ');
                            porcentagem := escritos /(tamanho+jagravados)  * 100;
sporcentagem := floattostrf(porcentagem,ffgeneral,3,2);
if pos ('E',sporcentagem) > 0 then
sporcentagem := copy(sporcentagem,1,pos('E',sporcentagem)-1);

    if tamanho+jagravados >= um_g then
sintetiza(sporcentagem+'% de '+inttostr ((tamanho+jagravados) div um_g)+ 'GB.')
else
    if tamanho+jagravados >= um_m then
sintetiza(sporcentagem+'% de '+inttostr ((tamanho+jagravados) div um_M)+ 'MB.')
    else
    if tamanho+jagravados >= um_k then
sintetiza(sporcentagem+'% de '+inttostr ((tamanho+jagravados) div um_k)+'KB.')
else
sintetiza(sporcentagem+'% de '+inttostr ((tamanho+jagravados))+'Bytes.');
end;

if recebidos >= um_g then
begin
recebidos := recebidos / um_g;
srecebidos := floattostrf(recebidos,ffgeneral,3,2);
sintetiza(srecebidos +' GigaBytes gravados.');
end
else
if recebidos >= um_m then
begin
recebidos := recebidos / um_m;
srecebidos := floattostrf(recebidos,ffgeneral,3,2);
sintetiza(srecebidos +' MegaBytes gravados.');
end
else
if recebidos >= um_k then
begin
recebidos := recebidos / um_k;
srecebidos := floattostrf(recebidos,ffgeneral,3,2);
sintetiza(srecebidos +' KBytes gravados.');
end
else
begin
srecebidos := floattostrf(recebidos,ffgeneral,3,2);
sintetiza(srecebidos +' Bytes gravados.');
end;
sintetiza ('Arquivo: '+nomearq);
sintetiza('');
//Sintetiza('Taxa de transferncia: ');
//sintetiza(taxatransf+' KBPS');
                        end
                    else
                    if c = #32 then
                        comclek := not comClek
                    else
                    if c = ESC then
                        begin
    sintwriteln('Deseja parar o download?');
                            c2 := sintreadkey;
                            writeln(c2);
                            if upcase(c2) = 'S' then
begin
Sintwriteln('O download foi interrompido.');
 goto fim;
end;
                        end;
                end;
        end;
fim:
    closefile(arq);
    fechaconexao(sock);
    fechawinsock;
    fimbufrede(buf);
    if (areceber <= 1) or (gravandoaudio)then download := true;
end;

{funo auxiliar, urlencode2}
function UrlEncode2(s: String): String;
var i: Integer;
begin
    Result := '';
    for i := 1 to length(s) do
        begin
            if s[i] in ['0'..'9', 'a'..'z', 'A'..'Z', '.', '-', '_', '~'] then
                Result := Result + s[i]
            else
                Result := Result + '%' + IntToHex(Ord(s[i]), 2);
        end;
end;


{comando mensagem}
function processamensagem(lido : string): boolean;
var atocar : string;
p : integer;
begin
    processamensagem := false;
    if lido = '' then exit;
    if not extraivalor(lido,atocar) then exit;
    atocar := maiuscansi(atocar);
    p := pos('.WAV',atocar);
    if p = 0 then
    atocar := atocar + '.WAV';
    waveplayfile(atocar);
    processamensagem := true;
end;

{comando trazdarede}

function processatrazdarede(lido: string):boolean;
var
modo,pagina, arquivo : string;
comclek: string;
cookies : string;
clekbin : boolean;
v : char;
begin
    processatrazdarede := false;
    if lido = '' then exit;
if not extraivalor (lido,pagina) then exit;
if not extraivalor (lido,arquivo) then exit;
if not extraivalor(lido,comclek) then exit;
extraivalor(lido,cookies);
    if not extraivariavel (lido,v) then exit;
    if comclek = '0' then
clekbin := false
else
if comclek = '1' then
clekbin := true
else
exit;

    if     download(pagina,arquivo,clekbin,cookies) then
    varscript[v] := '0'
    else
    varscript[v] := '1';
    processatrazdarede := true;
end;

{comando utf8paraansi}
function processautf8paraansi(lido: string): boolean;
var aconverter : string;
comando : string;
v : char;
begin
processautf8paraansi := false;
comando := lido;
if not extraivalor(lido,aconverter) then exit;
aconverter := utf8toansi(aconverter);
    if not extraivariavel(comando,v) then exit;
varscript[v] := aconverter;
    processautf8paraansi := true;
end;

{comando ansiparautf8}
function processaansiparautf8(lido: string): boolean;
var aconverter : string;
comando : string;
v : char;
begin
processaansiparautf8 := false;
comando := lido;
if not extraivalor(lido,aconverter) then exit;
aconverter := ansitoutf8(aconverter);
    if not extraivariavel(comando,v) then exit;
varscript[v] := aconverter;
    processaansiparautf8 := true;
end;

{comando http, converte de ansi para http}
function processahttp(lido: string): boolean;
var aconverter : string;
comando : string;
v : char;
begin
processahttp := false;
comando := lido;
if not extraivalor(lido,aconverter) then exit;
aconverter := urlencode2(aconverter);
    if not extraivariavel(comando,v) then exit;
varscript[v] := aconverter;
    processahttp := true;
end;

{codifica em base 64}
function processacodbase64(lido: string): boolean;
var aconverter : string;
comando : string;
v : char;
begin
processacodbase64 := false;
comando := lido;
if not extraivalor(lido,aconverter) then exit;
aconverter := codfrasemime64(aconverter);
    if not extraivariavel(comando,v) then exit;
varscript[v] := aconverter;
processacodbase64 := true;
end;

{decodifica base 64}
function processadecodbase64(lido: string): boolean;
var aconverter : string;
comando : string;
v : char;
begin
processadecodbase64 := false;
comando := lido;
if not extraivalor(lido,aconverter) then exit;
aconverter := decodfrasemime64(aconverter);
    if not extraivariavel(comando,v) then exit;
varscript[v] := aconverter;
processadecodbase64 := true;
end;

{comando codarqbase64 -
 codifica um arquivo binrio em base64
}

function processacodarqbase64(lido : string): boolean;
var arqentra, arqsai : string;
begin
    processacodarqbase64 := false;
    if not extraivalor (lido,arqentra) then exit;
    if not extraivalor (lido,arqsai) then exit;
    if not fileexists(arqentra) then exit;
    codifica(arqentra, arqsai);
    processacodarqbase64 := true;
end;

{comando decodarqbase64 -
transforma um arquivo de base64 para binrio
}
function processadecodarqbase64(lido : string): boolean;
var arqentra, arqsai : string;
begin
    processadecodarqbase64 := false;
    if not extraivalor (lido,arqentra) then exit;
    if not extraivalor (lido,arqsai) then exit;
    if not fileexists(arqentra) then exit;
    if not decodmime64(arqentra, arqsai) then exit;
    processadecodarqbase64 := true;
end;

{comando removequoted}

function processaremovequoted(lido: string):boolean;
var aconverter : string;
comando : string;
v : char;
begin
processaremovequoted := false;
comando := lido;
if not extraivalor(lido,aconverter) then exit;
aconverter := convquotedprintable(aconverter);
    if not extraivariavel(comando,v) then exit;
varscript[v] := aconverter;
    processaremovequoted := true;
end;

{comando adquoted}
function processaadquoted(lido : string): boolean;
var aconverter : string;
comando : string;
v : char;
begin
processaadquoted := false;
comando := lido;
if not extraivalor(lido,aconverter) then exit;
aconverter := encodequotedprintable(aconverter);
    if not extraivariavel(comando,v) then exit;
varscript[v] := aconverter;
    processaadquoted := true;
end;


{--------------------------------------------------------}
{ Procura uma lista por nome e retorna o ponteiro
{--------------------------------------------------------}

function procuraLista (lista: string): pListaRec;
var i: integer;
begin
procuraLista := nil;
for i := 0 to 19 do
begin
if varLista[i] = nil then continue;
if varlista[i]^.nome = lista then procuraLista := varLista[i];
end;
end;

{--------------------------------------------------------}
{ Verifica se h espaos vazios na varivel das listas
{--------------------------------------------------------}

function espacoVazioVarLista: integer;
var i: integer;
begin
espacoVazioVarLista := -1;
for i := 0 to 19 do
begin
if varLista[i] = nil then
begin
espacoVazioVarLista := i;
break;
end;
end;
end;

{--------------------------------------------------------}
{                  comando lista
{--------------------------------------------------------}

function processaLista(lido: string): boolean;
var v: string;
p: pListaRec;
i, i2: integer;
c: char;
begin
processaLista := false;
if not (extraiNomeLista(lido, v)) then exit;
lido := trim(lido);
if maiuscAnsi(copy(lido, 1, 4)) = 'CRIA' then
begin
delete(lido, 1, 4);
lido := trim(lido);
{ S para verificar a sintaxe }
if lido <> '' then exit;
if (procuraLista(v)) <> nil then
begin
sintWriteln(LISTA_JA_EXISTE);
exit;
end;
i := espacoVazioVarLista;
if i = -1 then
begin
sintWriteln(MUITAS_LISTAS);
exit;
end;
varLista[i] := criaLista;
varLista[i].nome := v;
end
else if maiuscAnsi(copy(lido, 1, 5)) = 'APAGA' then
begin
delete(lido, 1, 5);
lido := trim(lido);
{ S para verificar a sintaxe }
if lido <> '' then exit;
p := procuraLista(v);
for i := 0 to 19 do
begin
if varLista[i] = p then varLista[i] := nil;
end;
if p = nil then exit;
zeraLista (p);
p := nil;
end
else if maiuscAnsi(copy(lido, 1, 7)) = 'TAMANHO' then
begin
delete(lido, 1, 7);
p := procuraLista(v);
if p= nil then exit;
if not extraiVariavel(lido, c) then exit;
varScript[c] := inttostr(p^.lista.Count);
end
else if maiuscAnsi(copy(lido, 1, 4)) = 'ITEM' then
begin
delete(lido, 1, 4);
p := procuraLista(v);
if p= nil then exit;
if not extraiValor(lido, v) then exit;
val(v, i, i2);
if i2 <> 0 then exit;
if not extraiVariavel(lido, c) then exit;
try
varScript[c] := p^.lista[i];
except
exit;
end;
end
else if maiuscAnsi(copy(lido, 1, 8)) = 'ADICIONA' then
begin
delete(lido, 1, 8);
p := procuraLista(v);
if p= nil then exit;
if not extraiValor(lido, v) then exit;
try
p^.lista.add(v);
except
exit;
end;
end
else if maiuscAnsi(copy(lido, 1, 6)) = 'DELETA' then
begin
delete(lido, 1, 6);
p := procuraLista(v);
if p= nil then exit;
if not extraiValor(lido, v) then exit;
i := p^.lista.indexOf(v);
if i < 0 then exit;
try
p^.lista.Delete(i);
except
exit;
end;
end
else exit;
processaLista := true;
end;

{--------------------------------------------------------}
{                  comando escreve
{--------------------------------------------------------}

function processaEscreve (lido: string): boolean;
var pulaLinha: boolean;
arqSel: char;
mudo: boolean;
valor: string;
p: pchar;
saida: string;

function escreveArq (s: string; pulando: boolean): boolean;
label erro;
begin
escreveArq := false;

if arqSel = ' ' then
begin
if pulando then
writeln (s)
else
write (s);
if not mudo then sintetiza (s);
end
else
with arquivo[arqSel] do
begin
if not aberto then goto erro;
if not internet then
begin
{$I-}
if pulando then writeln (arq, s)
else write (arq, s);
{$I+}
statusUltIO := ioresult;
end
else
begin
p := @s[1];
if pulando then
                            statusUltIO := ord (writelnrede (soquete,s))
else
                            statusUltIO := ord (writerede (soquete,s))
end;
end;

escreveArq := true;
exit;

erro:
sintWriteln (ERRO_ARQUIVO);  {'Erro no processamento do arquivo'}
end;

begin
statusUltIO := 0;
processaEscreve := false;
mudo := false;

pulaLinha := true;
if (lido <> '') and (lido[length(lido)] = '&') then
begin
pulaLinha := false;
delete (lido, length (lido), 1);
lido := trim (lido);
end;

arqSel := ' ';
if (lido <> '') and (lido[1] = '#') then
begin
delete (lido, 1, 1);
if (lido = '') or not (lido[1] in ['0'..'9']) then
begin
sintWriteln (ERRO_ARQUIVO);  {'Erro no processamento do arquivo'}
exit;
end;
arqSel := lido[1];
delete (lido, 1, 1);
end
else
if maiuscAnsi (copy (lido, 1, 4)) = 'MUDO' then
begin
delete (lido, 1, 4);
mudo := true;
end;

lido := trim (lido);
if lido = '' then
escreveArq ('', true)
else
begin
saida := '';
while extraiValor (lido, valor) do
saida := saida + valor;
escreveArq (saida, pulaLinha);
if lido <> '' then exit;
end;

while sintFalando do;
processaEscreve := true;
end;

{--------------------------------------------------------}
{                  comando fala
{--------------------------------------------------------}

function processaFala (lido: string): boolean;
var
esperando: boolean;
valor: string;
saida: string;

begin
processaFala := false;

esperando := true;
if (lido <> '') and (lido[length(lido)] = '&') then
begin
esperando := false;
delete (lido, length (lido), 1);
lido := trim (lido);
end;

if lido = '' then
begin
sintPara;
if esperando then
while sintFalando do waitMessage;
processaFala := true;
exit;
end;

saida := '';
while extraiValor (lido, valor) do
saida := saida + valor;
sintetiza (saida);

if esperando then
while sintFalando do waitMessage;

if lido = '' then
processaFala := true;
end;

{--------------------------------------------------------}
{                  comando falahora
{--------------------------------------------------------}

function processaFalaHora (lido: string): boolean;
var v, hora, minuto: string;
begin
processaFalaHora := false;
if lido = '' then exit;
extraiValor(lido, v);
if (length(v)>5) or (length(v)<5) then exit;
if not (copy(v, 3, 1)=':') then exit;
hora := copy(v, 1, 2);
minuto := copy(v, 4, 5);
falaHoraQualquer(strToInt(hora), strToInt(minuto));
while sintFalando do waitMessage;
processaFalaHora := true;
end;

{--------------------------------------------------------}
{                  comando bipa
{--------------------------------------------------------}

function processaBipa (lido: string): boolean;
var tipo: string;
begin
processaBipa := false;

if lido = '' then
tipo := '0'
else
if not extraiValor (lido, tipo) then exit;

if tipo = '1' then
sintClek
else
sintBip;

processaBipa := true
end;

{--------------------------------------------------------}
{                  comando cor
{--------------------------------------------------------}

function processaCor (lido: string): boolean;
var valor: string;
cor, erro: integer;
begin
processaCor := false;

if lido = '' then exit;
if not extraiValor (lido, valor) then exit;
val (valor, cor, erro);
if erro <> 0 then exit;

textColor (cor);

processaCor := true
end;

{--------------------------------------------------------}
{                  comando Fundo
{--------------------------------------------------------}

function processaFundo (lido: string): boolean;
var valor: string;
cor, erro: integer;
begin
processaFundo := false;

if lido = '' then exit;
if not extraiValor (lido, valor) then exit;
val (valor, cor, erro);
if erro <> 0 then exit;

textBackground (cor);

processaFundo := true
end;

{--------------------------------------------------------}
{                     comando Tela
{--------------------------------------------------------}

function processaTela (lido: string): boolean;
var
p, x, y, erro: integer;
s: string;
begin
processaTela := false;
if lido = '' then exit;

lido := maiuscAnsi (lido);
if (length (lido) = 1) and (upcase(lido[1]) in ['A'..'Z']) then
lido := varScript[upcase(lido[1])];

if lido = 'LIMPA' then
clrscr
else
if lido = 'MINIMIZADA' then
showWindow (crtWindow, SW_HIDE)
else
if lido = 'NORMAL' then
begin
showWindow (crtWindow, SW_RESTORE);
bringWindowToTop (crtWindow);
end
else
if (lido <> '') and (lido [1] = '@') then
begin
delete (lido, 1, 1);
p := pos (',', lido);
s := copy (lido, 1, p-1);
s := trim(s);
delete (lido, 1, p);
lido := trim (lido);

val (s, x, erro);
if erro <> 0 then exit;
val (lido, y, erro);
if erro <> 0 then exit;

gotoxy (x, y);
end
else
exit;

processaTela := true;
end;

{--------------------------------------------------------}
{                  comando remove
{--------------------------------------------------------}

function processaRemove (lido: string): boolean;
var
nomeArq: string;
arq: file;
ignoraErro: boolean;

begin
processaRemove := false;
if lido = '' then exit;

ignoraErro := false;
if lido[length(lido)] = '&' then
begin
ignoraErro := true;
delete (lido, length (lido), 1);
lido := trim (lido);
end;

if not extraiValor (lido, nomeArq) then exit;
if nomeArq = '' then exit;

assign (arq, nomearq);
{$I-}  erase (arq);  {$I+}
if (ioresult <> 0) and not (ignoraErro) then
begin
sintWriteln (ERRO_APAGA + nomeArq);
exit;
end;

processaRemove := true;
end;

{--------------------------------------------------------}
{                  le a posio do mouse
{--------------------------------------------------------}

function lePosMouse (lido: string): boolean;
var
pt: TPOINT;
rect: TRECT;
xorig, yorig: integer;
v1, v2: char;
begin
lePosMouse:= false;
getCursorPos (pt);

if maiuscAnsi (copy (lido, 1, 4)) = 'TELA' then
begin
xorig := 0;
yorig := 0;
delete (lido, 1, 4);
lido := trim (lido);
end
else
begin
getWindowRect (getForegroundWindow, rect);
xorig := rect.left+getSystemMetrics (SM_CXFRAME);
yorig := rect.top+SM_CYCAPTION;
end;

if not extraiVariavel (lido, v1) then exit;
str (pt.x-xorig, varScript[v1]);
if not extraiVariavel (lido, v2) then exit;
str (pt.y-yorig, varScript[v2]);
if lido <> '' then exit;

lePosMouse:= true;
end;

{--------------------------------------------------------}
{                      comando le
{--------------------------------------------------------}

function processaLe (lido: string): boolean;
var
p:integer;
c: char;
s: string;
leLetra, leDeArquivo, editando, mudo, senha, letecla: boolean;
arqSel: char;
varDestino: char;
salvaCor: word;
flags:string;

label erro;

begin
statusUltIO := 0;
mudo := false;
senha := false;
editando := false;
letecla:=false;
lido := trim (lido);
if lido = '' then
begin
readln;
processaLe := true;
exit;
end;

if (maiuscAnsi (copy (lido, 1, 6)) = 'MOUSE ') or
(maiuscAnsi (copy (lido, 1, 5)) = 'RATO ') then
begin
delete (lido, 1, 5);
lido := trim (lido);
processaLe := lePosMouse (lido);
exit;
end;

p:=pos('TECLA ',maiuscAnsi(lido));
if p>0 then
begin
delete(lido,p,6);
lido:=trim (lido);
if lido[length(lido)]<>'&' then lido:=lido+'&';
letecla:=true;
end;

processaLe := false;

leLetra := false;
if lido [length(lido)] = '&' then
begin
leLetra := true;
delete (lido, length(lido), 1);
lido := trim (lido);
end;

if lido = '' then
begin
readkey;
processaLe := true;
exit;
end;

leDeArquivo := false;
if lido [1] = '#' then
begin
if not extraiNumArq (lido, arqSel) then exit;
if lido = '' then goto erro;
leDeArquivo := true;
end
else
if maiuscAnsi (copy (lido, 1, 5)) = 'EDITA' then
begin
delete (lido, 1, 5);
editando := true;
end
else
if maiuscAnsi (copy (lido, 1,8 )) = 'CONSOLE ' then
begin
delete (lido, 1, 8);
if not extraiVariavel(lido,varDestino) then exit;
s := appgetout;
varScript[varDestino] := s;
processale := true;
end
else
if maiuscAnsi (copy (lido, 1, 4)) = 'MUDO' then
begin
delete (lido, 1, 4);
mudo := true;
end
else
if maiuscAnsi (copy (lido, 1, 5)) = 'SENHA' then
begin
delete (lido, 1, 5);
mudo := true;
senha := true;
end;

lido := trim (lido);
if not extraiVariavel(lido,varDestino) then exit;

if leDeArquivo then
with arquivo[arqSel] do
begin
if internet then
begin
statusUltIO := ord (not readlnBufRede (pbuf, s, 30));
end
else
begin
if eof (arq) then
statusUltIO := 1
else
begin
{$I-} readln (arq, s); {$I+}
statusUltIo := ioresult;
end
end
end
else
begin
if leLetra then
begin
if mudo then
c:=readKey
else
c := sintReadkey;
if (c>=' ') then
if letecla then begin
str(ord(c),s);
flags:=getflags;
s:=flags+'#'+s; end
else
s:=c
else
if c=#$0 then
begin
c:=readkey;
str(ord(c),s);
s:='#0#'+s;
if letecla then begin
flags:=getflags;
s:=flags+s; end;
end
else
begin
str (ord(c),s);
s:='#'+s;
if letecla then begin
flags:=getflags;
s:=flags+s; end;
end;
end
else
begin
salvaCor := textAttr;
if senha then textAttr := 0;
if mudo then
readln (s)
else
if editando then
begin
s := varScript[varDestino];
c := sintEdita (s, wherex, wherey, 80, true);
if c = ESC then s := '';
end
else
sintReadln (s);
textAttr := salvaCor;
end;
end;

varScript[varDestino] := s;
processaLe := true;

exit;

erro:
sintWriteln (ERRO_ARQUIVO);  {'Erro no processamento do arquivo'}
end;

{--------------------------------------------------------}
{                  comando cmd
{--------------------------------------------------------}

function processaCmd (lido: string): boolean;   {recursivo, provavelmente}
var s: string;
begin
processaCmd := false;

if not extraiValor (lido, s) then exit;
if lido <> '' then exit;

processaCmd := cmdScript (s);
end;

{--------------------------------------------------------}
{                  Comando espera
{--------------------------------------------------------}

function processaEspera (lido: string): boolean;
var
milisegundos: boolean;
erro: integer;
i, n: longint;
s, nomeJan: string;
titulo: array [0..250] of char;
begin
milisegundos := false;
processaEspera := false;
if lido = '' then exit;
statusUltIO := 0;

if (maiuscAnsi(copy(lido, 1,2)) = 'MS') then
begin
delete(lido, 1,2);
milisegundos := true;
end;

if not extraiValor (lido, s) then exit;
val (s, n, erro);
if erro <> 0 then exit;

processaEspera := true;

lido := trim (lido);
if lido = '' then
begin
if not milisegundos then delay(n*1000)
else delay (n);
exit;
end;

if not extraiValor (lido, nomeJan) then exit;
nomeJan := maiuscAnsi (nomeJan);

n := n * 2;
for i := 1 to n do
begin
getWindowText (getForegroundWindow, titulo, 250);
if pos (nomeJan, maiuscAnsi (strPas (titulo))) <> 0 then exit;
delay (500);
end;

statusUltIO := 1;   { no chegou... }
end;

{--------------------------------------------------------}
{                  Comando digita
{--------------------------------------------------------}

function processaDigita (lido: string): boolean;
var s: string;
poeEnter: boolean;
begin
processaDigita := false;

poeEnter := true;
if (lido <> '') and (lido[length(lido)] = '&') then
begin
poeEnter := false;
delete (lido, length (lido), 1);
lido := trim (lido);
end;

if not extraiValor (lido, s) then exit;
if lido <> '' then exit;

keyboardString (s, 100);
if poeEnter then
keyboardVirtKey (VK_RETURN, false, false, false, 100);

processaDigita := true;
end;

{--------------------------------------------------------}
{                  Comando aciona
{--------------------------------------------------------}

function processaAciona (lido: string): boolean;
var s: string;
letra: char;
n, erro: integer;
comCtl, comShift, comAlt: boolean;

begin
processaAciona := false;
if not extraiValor (lido, s) then exit;
if s = '' then exit;
if lido <> '' then exit;

if length (s) = 1 then
keyboardClick (s[1])
else
begin
s := maiuscAnsi (s);

comCtl := false;
if copy (s, 1, 5) = 'CTRL+' then
begin
comCtl := true;
delete (s, 1, 5);
end;
comShift := false;
if copy (s, 1, 6) = 'SHIFT+'   then
begin
comShift := true;
delete (s, 1, 6);
end;

comAlt := false;
if copy (s, 1, 4) = 'ALT+'     then
begin
comAlt := true;
delete (s, 1, 4);
end;

if s = '' then exit;

if s = 'UP'        then n := VK_UP       else
if s = 'DOWN'      then n := VK_DOWN     else
if s = 'LEFT'      then n := VK_LEFT     else
if s = 'RIGHT'     then n := VK_RIGHT    else
if s = 'ESCAPE'    then n := VK_ESCAPE   else
if s = 'ESC'       then n := VK_ESCAPE   else
if s = 'ENTER'     then n := VK_RETURN   else
if s = 'RETURN'    then n := VK_RETURN   else
if s = 'BACKSPACE' then n := VK_BACK     else
if s = 'TAB'       then n := VK_TAB      else
if s = 'F1'        then n := VK_F1       else
if s = 'F2'        then n := VK_F2       else
if s = 'F3'        then n := VK_F3       else
if s = 'F4'        then n := VK_F4       else
if s = 'F5'        then n := VK_F5       else
if s = 'F6'        then n := VK_F6       else
if s = 'F7'        then n := VK_F7       else
if s = 'F8'        then n := VK_F8       else
if s = 'F9'        then n := VK_F9       else
if s = 'F10'       then n := VK_F10      else
if s = 'F11'       then n := VK_F11      else
if s = 'F12'       then n := VK_F12      else
if s = 'INS'       then n := VK_INSERT   else
if s = 'HOME'      then n := VK_HOME     else
if s = 'DEL'       then n := VK_DELETE   else
if s = 'DELETE'    then n := VK_DELETE   else
if s = 'HOME'      then n := VK_HOME     else
if s = 'END'       then n := VK_END      else
if s = 'PAGEUP'    then n := VK_PRIOR    else
if s = 'PAGEDN'    then n := VK_NEXT     else
if s = 'PRIOR'     then n := VK_PRIOR    else
if s = 'NEXT'      then n := VK_NEXT     else
if s = 'SNAPSHOT'  then n := VK_SNAPSHOT
else
begin
letra := upcase(s[1]);
n := ord (letra);
delete (s, 1, 1);
if letra = '#' then
begin
val (s, n, erro);
if erro <> 0 then exit;
end
else
if s <> '' then exit;
end;

keyboardVirtKey (n, comCtl, comShift, comAlt, 100);
end;

processaAciona := true;
end;

{--------------------------------------------------------}
{                  Comando Clica
{--------------------------------------------------------}

function processaClica (lido: string): boolean;
var rect: TRect;
s: string;
x, y, xorig, yorig, erro: integer;
estiloClick: (SIMPLES, DUPLO, NULO);
begin
processaClica := false;

estiloClick := SIMPLES;

lido := trim (lido);
if maiuscAnsi (copy (lido, 1, 5)) = 'DUPLO' then
begin
estiloClick := DUPLO;
delete (lido, 1, 5);
end
else
if maiuscAnsi (copy (lido, 1, 4)) = 'NULO' then
begin
estiloClick := NULO;
delete (lido, 1, 4);
end;

lido := trim (lido);
if maiuscAnsi (copy (lido, 1, 4)) = 'TELA' then
begin
xorig := 0;
yorig := 0;
delete (lido, 1, 4);
end
else
begin
getWindowRect (getForegroundWindow, rect);
xorig := rect.left+getSystemMetrics (SM_CXFRAME);
yorig := rect.top+SM_CYCAPTION;
end;

if not extraiValor (lido, s) then exit;
val (s, x, erro);
if erro <> 0 then exit;

lido := trim (lido);
if (lido <> '') and (lido[1] = ',') then delete (lido, 1, 1);

if not extraiValor (lido, s) then exit;
val (s, y, erro);
if erro <> 0 then exit;

case estiloClick of
SIMPLES:  mouseClick (x+xorig, y+yorig);
DUPLO:    mouseDoubleClick (x+xorig, y+yorig);
NULO:     mouseMove (x+xorig, y+yorig);
end;

if lido <> '' then exit;
processaClica := true;
end;

{--------------------------------------------------------}
{                  Comando Transfere
{--------------------------------------------------------}

function processaTransfere (lido: string): boolean;
var v: char;
p: array [0..255] of char;
trazendo: boolean;
begin
processaTransfere := false;
if lido = '' then exit;

if maiuscAnsi (copy (lido, 1, 3)) = 'DE ' then
begin
trazendo := false;
delete (lido, 1, 3);
end
else
if maiuscAnsi (copy (lido, 1, 5)) = 'PARA ' then
begin
trazendo := true;
delete (lido, 1, 5);
end
else
exit;

if not extraiVariavel (lido, v) then exit;
lido := trim (lido);
if lido <> '' then exit;

if trazendo then
begin
getClipBoard (p, 255);
varScript[v] := strPas (p);
end
else
begin
strPCopy (p, varScript[v]);
putClipBoard (p);
end;

processaTransfere := true;
end;

{--------------------------------------------------------}
{                  Comando janela
{--------------------------------------------------------}

function processaJanela (lido: string): boolean;
var
currWnd: hwnd;
txt: array [0..144] of char;
p: integer;
opcao, titulo, s: string;
aoInicio, aoFim, visivel, iconica: boolean;

label prox, achou;

begin
processaJanela := false;
statusUltIO := 0;
if lido = '' then exit;

opcao := '';
while (lido <> '') and (lido[1] <> ' ') do
begin
opcao := opcao + lido[1];
delete (lido, 1, 1);
end;
opcao := maiuscAnsi (opcao);

lido := trim (lido);
if not extraiValor (lido, s) then exit;

CurrWnd := GetWindow(crtWindow, GW_HWNDFIRST);

aoInicio := false;
aoFim := false;
if (s <> '') and (s[1] = '*') then
begin
aoInicio := true;
delete (s, 1, 1);
end;

if (s <> '') and (s[length(s)] = '*') then
begin
aoFim := true;
delete (s, length (s), 1);
end;

While CurrWnd <> 0 do
begin
if isWindowEnabled (currWnd) then
begin
visivel := isWindowVisible (currWnd);
iconica := isIconic (currWnd);
GetWindowText(CurrWnd, txt, 144);
titulo := maiuscAnsi (strPas (txt));

if ((visivel or iconica) and (length (titulo) <> 0)) then
begin
p := pos (s, titulo);
if (p = 0)  or
((p <> 1) and aoInicio) or
((p <> (length(titulo) - length(s) + 1)) and aoFim) then
goto prox;

goto achou;
end;
end;
prox:
CurrWnd := GetWindow(CurrWnd, GW_HWNDNEXT);
end;

processaJanela := true;
statusUltIO := 1;
exit;   { no achou }

achou:
if opcao = 'FECHA' then
sendMessage (currWnd, WM_CLOSE, 0, 0)
else
if opcao = 'NORMAL' then
begin
ShowWindow(currWnd, SW_SHOWNORMAL);
setActiveWindow (currWnd);
end
else
if opcao = 'MAXIMIZA' then
begin
ShowWindow(currWnd, SW_MAXIMIZE);
setActiveWindow (currWnd);
end
else
if opcao = 'MINIMIZA' then
ShowWindow(currWnd, SW_MINIMIZE)
else
exit;

processaJanela := true;
end;

{--------------------------------------------------------}
{                  Comando Captura
{--------------------------------------------------------}

function processaCaptura (lido: string): boolean;
var v: char;
p: array [0..255] of char;
opcao: string;
begin
processaCaptura := false;
if lido = '' then
exit;

opcao := '';
while (lido <> '') and (lido[1] <> ' ') do
begin
opcao := opcao + lido[1];
delete (lido, 1, 1);
end;
opcao := maiuscAnsi (opcao);

if not extraiVariavel (lido, v) then exit;

if (opcao = 'TTULO') or (opcao = 'TITULO') or (opcao = 'ATIVA') then
getWindowText (getForegroundWindow, p, 255)
else
if (opcao = 'FOCO') then
begin
strcopy (p, '');
if getFocus <> 0 then
getWindowText (getFocus, p, 255);
end
else
if (opcao = 'CAMPO') then
begin
keyboardVirtKey (VK_HOME, false, false, false, 100);
keyboardVirtKey (VK_END, false, true, false, 100);
keyboardVirtKey (VK_INSERT, true, false, false, 100);
getClipBoard (p, 255);
end;

varScript[v] := strPas (p);
processaCaptura := true;
end;

{--------------------------------------------------------}
{                  Comando desvia
{--------------------------------------------------------}

function processaDesvia (lido: string): boolean;
var s: string;
begin
processaDesvia := false;
if fimScript then exit;   { processamento fora de arquivo }
if lido = '' then exit;

if (lido <> '') and (lido[1] = '@') then
begin
delete (lido, 1, 1);
s := lido;
if pos (' ', s) <> 0 then exit;  {rotulo com brancos}
end
else
begin
if not extraiValor (lido, s) then exit;
if lido <> '' then exit;
end;

processaDesvia := buscaRotulo (s);
end;

{--------------------------------------------------------}
{        procedimentos comuns de se e enquanto
{--------------------------------------------------------}

function processaTestes (var lido: string; var resultado: boolean): boolean;
var valor1, valor2, mv1, mv2: string;
operador: string[3];
lista: pListaRec;
c: integer;
nega: boolean;

function compensaNumero (s: string): string;
var i: integer;
begin
compensaNumero := s;
for i := 1 to length (s) do
if not (s[i] in ['0'..'9']) then exit;

s := '00000000000000000000' + s;
s := copy (s, length(s)-20, 255);
compensaNumero := s;
end;

label ok, fim;
begin
processaTestes := false;
resultado := false;
if lido = '' then exit;

nega := false;
if (maiuscAnsi (copy (lido, 1, 3)) = 'NO') or
(maiuscAnsi (copy (lido, 1, 3)) = 'NAO') then
begin
delete (lido, 1, 3);
lido := trim (lido);
if lido = '' then exit;
nega := true;
end;

if not extraiValor (lido, valor1) then exit;
if lido = '' then exit;

if copy (lido, 1, 2) = '>='  then operador := '>='  else
if copy (lido, 1, 2) = '<='  then operador := '<='  else
if copy (lido, 1, 2) = '=='  then operador := '=='  else
if copy (lido, 1, 2) = '<>'  then operador := '<>'  else
if copy (lido, 1, 3) = '*=*' then operador := '*=*' else
if copy (lido, 1, 2) = '=*'  then operador := '=*'  else
if copy (lido, 1, 2) = '*='  then operador := '*='  else
if maiuscAnsi(copy(lido, 1, 2)) = 'EM' then operador := 'EM' else
if lido[1] = '=' then operador := '=' else
if lido[1] = '<' then operador := '<' else
if lido[1] = '>' then operador := '>'
else
exit;

delete (lido, 1, length (operador));
lido := trim (lido);
if lido = '' then exit;

if operador <> 'EM' then
begin
if not extraiValor (lido, valor2) then exit;

mv1 := compensaNumero (maiuscAnsi(valor1));
mv2 := compensaNumero (maiuscAnsi(valor2));
end;

if operador = 'EM' then
begin
if not (extraiNomeLista(lido, valor2)) then exit;
lista := procuraLista(valor2);
if lista = nil then exit;
mv1 := compensaNumero (maiuscAnsi(valor1));
for c := 0 to lista^.lista.Count - 1 do
begin
mv2 := compensaNumero(maiuscAnsi(lista^.lista[c]));
if (nega xor (mv1 = mv2)) then goto ok;
end;
end;


if (operador = '=')   and (nega xor (mv1 = mv2)) then goto ok;
if (operador = '<')   and (nega xor (mv1 < mv2)) then goto ok;
if (operador = '>')   and (nega xor (mv1 > mv2)) then goto ok;

if (operador = '<=')  and (nega xor (mv1 <= mv2))         then goto ok;
if (operador = '>=')  and (nega xor (mv1 >= mv2))         then goto ok;
if (operador = '<>')  and (nega xor (mv1 <> mv2))         then goto ok;

if (operador = '==')  and (nega xor (valor1 = valor2))    then goto ok;
if (operador = '*=*') and (nega xor (pos (valor2, valor1) <> 0)) then goto ok;
if (operador = '=*')  and (nega xor (pos (valor2, valor1) = 1))  then goto ok;
if (operador = '*=')  and
(nega xor (pos (valor2, valor1) = length(valor1)-length(valor2)+1)) then
goto ok;

goto fim;   { com resultado falso }

ok:
resultado := true;
fim:
processaTestes := true;
lido := trim (lido);
end;

{--------------------------------------------------------}
{                  Comando se
{--------------------------------------------------------}

function processaSe (lido: string): boolean;
var verdadeiro: boolean;

procedure buscaSenaoOuFimSe;
var i, nivel: integer;
lido: string;
x: boolean;
begin
nivel := 1;
for i := linhaAtual+1 to nlinhasScript do
begin
lido := script[i];
lido := trim (lido);
lido := maiuscAnsi (lido);
while pos ('  ', lido) <> 0 do delete (lido, pos ('  ', lido), 1);
if copy (lido, 1, 3) = 'SE ' then
begin
delete (lido, 1, 3);
if processaTestes (lido, x) then
if trim (lido) = '' then
nivel := nivel + 1;
end
else
if lido = 'FIM SE' then
begin
nivel := nivel - 1;
if nivel = 0 then
linhaAtual := i;
exit;
end
else
if (lido = 'SENAO') or (lido = 'SENO') then
begin
if nivel = 1 then
linhaAtual := i;
exit;
end;
end;

linhaAtual := nlinhasScript + 1;
end;

begin
processaSe := false;
if not processaTestes (lido, verdadeiro) then exit;

processaSe := true;

if verdadeiro then
begin
if lido <> '' then processaSe := cmdScript (lido);
end
else
begin
if lido =  '' then  buscaSenaoOuFimSe;
end;
end;

{--------------------------------------------------------}
{                busca um comando fim
{--------------------------------------------------------}

procedure buscaFim (deQue: string);
var i: integer;
lido: string;
begin
for i := linhaAtual+1 to nlinhasScript do
begin
lido := script[i];
lido := trim (lido);
lido := maiuscAnsi (lido);
while pos ('  ', lido) <> 0 do delete (lido, pos ('  ', lido), 1);
if lido = 'FIM ' + deQue then
begin
linhaAtual := i;
exit;
end;
end;

linhaAtual := nLinhasScript + 1;
end;

{--------------------------------------------------------}
{                  Comando enquanto
{--------------------------------------------------------}

function processaEnquanto (lido: string): boolean;
var verdadeiro: boolean;

begin
processaEnquanto := false;
if not processaTestes (lido, verdadeiro) then exit;

if not verdadeiro then
buscaFim ('ENQUANTO');

processaEnquanto := true;
end;

{--------------------------------------------------------}
{                  Comando seno
{--------------------------------------------------------}

function processaSenao (lido: string): boolean;
begin
processaSenao := false;
if lido <> '' then exit;

buscaFim ('SE');

processaSenao := true;
end;

{--------------------------------------------------------}
{                  Comando repete
{--------------------------------------------------------}

function processaRepete (lido: string; continuando: boolean): boolean;
var natual, nmax: longint;
valor: string;
v: char;
erro: integer;

begin
processaRepete := false;

if not extraiVariavel (lido, v) then exit;
if lido = '' then exit;

if continuando then
begin
val (varScript[v], natual, erro);
if erro <> 0 then exit;
end
else
natual := 0;

if not extraiValor (lido, valor) then exit;
val (valor, nmax, erro);
if erro <> 0 then exit;

natual := natual + 1;
str (natual, varScript[v]);

if natual > nmax then
buscaFim ('REPETE');

processaRepete := true;
end;

{--------------------------------------------------------}
{                  Comandos de fim de bloco
{--------------------------------------------------------}

function processaFimBloco (lido: string): boolean;
var i, p: integer;
cmd: string;
begin
processaFimBloco := false;
if lido = '' then exit;

lido := maiuscAnsi (lido);
if lido = 'SE' then
begin
processaFimBloco := true;
exit;
end;

if lido = 'ENQUANTO' then
begin
for i := linhaAtual-1 downto 1 do
begin
lido := script[i];
lido := trim (lido);
lido := maiuscAnsi (lido);
lido := copy (lido, 1, pos (' ', lido)-1);
if lido = 'ENQUANTO' then
begin
linhaAtual := i - 1;
processaFimBloco := true;
exit;
end;
end;

exit;  { retorna erro se no achou Enquanto }
end;

if lido = 'REPETE' then
begin
for i := linhaAtual-1 downto 1 do
begin
lido := script[i];
lido := trim (lido);
lido := maiuscAnsi (lido);
p := pos (' ', lido);
cmd := copy (lido, 1, p-1);
delete (lido, 1, p);
lido := trim (lido);
if cmd = 'REPETE' then
begin
linhaAtual := i;
processaFimBloco := processaRepete (lido, true);
exit;
end;
end;

exit;  { retorna erro se no achou Repete }
end;

processaFimBloco := true;
end;

{--------------------------------------------------------}
{                  Comando executa
{--------------------------------------------------------}

function processaExecuta (lido: string): boolean;
var comando, param, nomeDir: string;
espera, escondido, leconsole : boolean;
i: integer;

label pulaparaleconsole, pulaparaescondido;
begin
processaExecuta := false;

espera := true;
escondido := false;
leconsole := false;

if (lido <> '') and (lido [length(lido)] = '&') then
begin
espera := false;
delete (lido, length (lido), 1);
lido := trim (lido);
end;
if (lido <> '') and (lido [length(lido)] = '&') then
begin
escondido := true;
delete (lido, length (lido), 1);
lido := trim (lido);
end;
if (lido <> '') and (lido [length(lido)] = '&') then
begin
leconsole := true;
delete (lido, length (lido), 1);
lido := trim (lido);
end;

if not extraiValor (lido, comando) then exit;
if lido <> '' then exit;

if (comando <> '') and (comando[1] = '"') then
begin
delete (comando, 1, 1);
i := pos ('"', comando);
if i = 0 then
param := ''
else
begin
param := copy (comando, i+1, 999);
param := trim(param);
comando := copy (comando, 1, i-1);
end;
end
else
begin
i := pos (' ', comando);
if i = 0 then
param := ''
else
begin
param := copy (comando, i+1, 999);
delete (comando, i, 999);
end;
end;

getdir (0, nomeDir);
while sintFalando do;
if escondido then goto pulaparaescondido;
if executaProg (comando, nomeDir, param) >= 32 then
begin
processaexecuta := true;
if espera then esperaProgVoltar
else
exit;
end;

pulaparaescondido:
if leconsole then goto pulaparaleconsole;
if shellexecute(hwnd(0),pchar('open'),pchar(comando),pchar(param),pchar(nomedir),sw_hide)  >= 32 then
begin
processaexecuta := true;
exit;
end;

pulaparaleconsole:
if param <> '' then comando := comando + ' ' + param;
if not appexecute(comando) then exit;
processaexecuta := true;
end;

{Comando existeprog}
function processaexisteprog (lido: string): boolean;
var nomeprog : string;
v : char;
begin
processaexisteprog := false;
if not extraivalor (lido,nomeprog) then exit;
nomeprog := trim(nomeprog);
if not extraivariavel (lido,v) then exit;
if processexists(nomeprog) then
varscript[v] := '1'
else
varscript[v] := '0';
processaexisteprog := true;
end;
{ Comando alarme }

function processaalarme (lido: string): boolean;
var freq, duracao: string;
begin

    processaAlarme := false;

if lido = '' then exit;

if not extraivalor (lido, freq) then exit;
if not extraiValor (lido, duracao) then exit;

    if strToInt(freq) > 20000 then exit;
    if strToInt(duracao) > 20000 then exit;
    if strToInt(freq) < 0 then exit;
    if strToInt(duracao) < 0 then exit;

    delete (lido, 1, length(lido));

    Windows.Beep (strToInt(freq), strToInt(duracao));

    processaAlarme := true;
    end;

{ Comando gravabytes }

function processaGravaBytes (lido: string; var bytesgravados: integer): boolean;

var
escritos, vazio: integer;

begin

    processaGravaBytes := false;

    vazio := sizeof(arqbytes)-bytesgravados; { Copia apenas os bytes reais alocados na memria }

    if BinAberto then
    begin
    blockwrite (arqbin, arqbytes, sizeof(arqbytes)-vazio, escritos);
    end
    else
    exit;

    bytesgravados := 0;

    processaGravaBytes := true;
    end;

{ Comando escrevebyte }

function processaEscreveByte (lido: string; var bytesgravados: integer): boolean;
var
fByte: Byte;
s: string;
i: integer;

begin

    processaEscreveByte := false;

    if not extraiValor (lido, s) then exit;

    for i := 1 to length(s) do
    begin
    fByte := ord(s[i]);
    arqbytes[bytesgravados] := fByte;
    bytesgravados := bytesgravados + 1;
    end;

    processaEscreveByte := true;
    end;

{ Comando lebyte }

function processaLeByte (lido: string; var bytesgravados: integer): boolean;
var nomeArq, s, t: string;
arq: File of Byte;
DadosALer, fimByte, i, lByte, inicByte, PosicBuffer: integer;

begin

    processaLeByte := false;

    PosicBuffer := 0;

    if not extraiValor (lido, nomeArq) then exit;
    if not extraiValor (lido, s) then exit;
    if not extraiValor (lido, t) then exit;

    if bytesgravados = 134217728 then exit;

    inicByte := strToInt(s);
    fimByte := strToInt(t);

    {$I-}

    assign (arq, nomeArq);

    reset (arq);

    if filesize(arq) > 134217728 then
    begin
        close (arq);
        exit;
    end;

    if ioresult <> 0 then exit;

    DadosALer := fimByte-inicByte;;

    if inicByte > fimByte then exit;

    if inicByte = fimByte then DadosALer := 1;

    seek(arq, inicByte);

    if eof (arq) then exit;

    blockread (arq, BufRead, DadosALer, lByte);

    {$I+}

    for i := 1 to DadosALer do
    begin
    arqbytes[bytesgravados] := BufRead[PosicBuffer];
    bytesgravados := bytesgravados+1;
    PosicBuffer := PosicBuffer + 1;
    end;

    processaLeByte := true;
    end;

{ Comando limpabytes }

function processaLimpaBytes: boolean;
var i: integer;
begin

    processaLimpaBytes := false;

    for i := 0 to sizeof(arqbytes) do
        begin
    arqbytes[i] := 0;
    end;

    bytesgravados := 0;

    processaLimpaBytes := true;
    end;

{ Comando fechabin }

function processaFechaBin: boolean;
begin

    processaFechaBin := false;

    if BinAberto then
    begin
    close (arqbin);
    BinAberto := false;
    end
    else
    exit;

    processaFechaBin := true;
    end;

{ Comando criabin }

function processaCriaBin (lido: string): boolean;
var nomeArq: string;
begin

    processaCriaBin := false;

    if not extraiValor (lido, nomeArq) then exit;

    if fileExists(nomeArq) then exit;

    {$I-}

    assign(arqbin,nomeArq);

    if BinAberto then exit;

    reset (arqbin);

    if ioresult <> 0 then rewrite (arqbin);

    BinAberto := true;

    {$I+}

    processaCriaBin := true;
    end;

{ Comando tamarq }

function processaTamArq (lido: string): boolean;
var nomeArq: string; v: char; arq: file of Byte; i: integer;

begin

    processaTamArq := false;

    if not extraiValor (lido, nomeArq) then exit;
    if not extraiVariavel (lido, v) then exit;

    assign(arq, nomeArq);

    {$I-}

    reset (arq);

    i := filesize(arq);

    varScript[v] := intToStr(i);

    processaTamArq := true;
    end;

{--------------------------------------------------------}
{                  Comando Termina
{--------------------------------------------------------}

function processaTermina (lido: string): boolean;
begin
fimScript := true;
fimScriptMudo := false;
if maiuscAnsi(lido) = 'MUDO' then
fimScriptMudo := true;
processaTermina := true;
end;

{--------------------------------------------------------}
{                  Comando chama
{--------------------------------------------------------}

function processaChama (lido: string): boolean;
var s: string;
begin
processaChama := false;
if fimScript then exit;   { processamento fora de arquivo }
if lido = '' then exit;

if lido[1] = '@' then
begin
delete (lido, 1, 1);
s := lido;
if pos (' ', s) <> 0 then exit;  {rotulo com brancos}
end
else
begin
if not extraiValor (lido, s) then exit;
if lido <> '' then exit;
end;

if topoRetorno < MAXRETORNO then
begin
topoRetorno := topoRetorno + 1;
pilhaRetorno[topoRetorno] := linhaAtual;
end
else
begin
sintWriteln (STACK_OVERFLOW);  {'Muitas chamadas sem retorno'}
exit;
end;

processaChama := buscaRotulo (s);
end;

{--------------------------------------------------------}
{                  Comando Busca
{--------------------------------------------------------}

function processaBusca (lido: string): boolean;
var v: char;
valor: string;
emDiretorio: boolean;
pvalor: array [0..144] of char;
begin
processaBusca := false;

if not extraiVariavel (lido, v) then exit;
if lido = '' then exit;

emDiretorio := false;
if maiuscAnsi (copy (lido, 1, 3)) = 'DIR' then
begin
emDiretorio := true;
delete (lido, 1, 4);
lido := trim (lido);
end;

if (maiuscAnsi (copy (lido, 1, 7)) = 'PRXIMO') or
(maiuscAnsi (copy (lido, 1, 7)) = 'PROXIMO') then
begin
delete (lido, 1, 7);
if lido <> '' then exit;

repeat
if FindNext(DirInfo) = 0 then
begin
if dirInfo.attr and atribBusca <> 0 then
varScript [v] := DirInfo.FindData.cFileName
end
else
begin
varScript [v] := '';
break;
end;
until dirInfo.attr and atribBusca <> 0;
end
else
if lido = '' then
getDir (0, varScript [v])
else
begin
if not extraiValor (lido, valor) then exit;
if lido <> '' then exit;

if emDiretorio then atribBusca := FaDirectory
else atribBusca := FaArchive;

strPCopy (pvalor, valor);
if FindFirst(pvalor, atribBusca, DirInfo) = 0 then
varScript [v] := DirInfo.FindData.cFileName
else
varScript [v] := '';
end;

varScript[v] := trim (varScript [v]);
processaBusca := true;
end;

{--------------------------------------------------------}
{                  Comando Renomeia
{--------------------------------------------------------}

function processaRenomeia (lido: string): boolean;
var nomeArq1, nomeArq2: string;
ignoraErro: boolean;
begin
processaRenomeia := false;
if lido = '' then exit;

ignoraErro := false;
if lido[length(lido)] = '&' then
begin
ignoraErro := true;
delete (lido, 1, length (lido));
lido := trim (lido);
end;

if not extraiValor (lido, nomeArq1) then exit;
if not extraiValor (lido, nomeArq2) then exit;
if lido <> '' then exit;

assign (arq, nomeArq1);
{$I-} rename (arq, nomeArq2);  {$I+}
if (ioresult <> 0) and (not ignoraErro) then exit;

processaRenomeia := true;
end;

{--------------------------------------------------------}
{                  Comando Replica
{--------------------------------------------------------}

function processaReplica (lido: string): boolean;
type
pvet30k = ^vet30k;
vet30k = array [0..29999] of byte;

var nomeArq1, nomeArq2: string;
ignoraErro: boolean;
arq1, arq2: file;
buf: pvet30k;
lidos, escritos: integer;
label fim;

begin
processaReplica := false;
if lido = '' then exit;

ignoraErro := false;
if lido[length(lido)] = '&' then
begin
ignoraErro := true;
delete (lido, 1, length (lido));
end;

if not extraiValor (lido, nomeArq1) then exit;
if not extraiValor (lido, nomeArq2) then exit;
if lido <> '' then exit;

new (buf);

assign (arq1, nomeArq1);
assign (arq2, nomeArq2);
{$I-} reset (arq1, 1);  {$I+}
if (ioresult <> 0) and (not ignoraErro) then goto fim;
{$I-} rewrite (arq2, 1);  {$I+}
if (ioresult <> 0) and (not ignoraErro) then goto fim;

while not eof (arq1) do
begin
{$I-} blockRead (arq1, buf^, sizeof(buf^), lidos);  {$I+}
if (ioresult <> 0) and (not ignoraErro) then
begin
sintWriteln (ERRO_ARQUIVO + ' ' + nomearq1);
goto fim;
end;

{$I-} blockWrite (arq2, buf^, lidos, escritos);  {$I+}
if (escritos <> lidos) and (not ignoraErro) then
begin
sintWriteln (ERRO_ESCRITA + ' ' + nomearq2);
goto fim;
end;
end;

processaReplica := true;

fim:
dispose (buf);
{$I-}  close (arq1);  {$I+}
if ioresult <> 0 then;
{$I-}  close (arq2);  {$I+}
if ioresult <> 0 then;
end;

{--------------------------------------------------------}
{                  Comando Dir
{--------------------------------------------------------}

function processaDir (lido: string): boolean;
var op: char;
nomeDir: string;
ignoraErro: boolean;
begin
processaDir := false;
ignoraErro := false;

if (lido <> '') and (lido [length(lido)] = '&') then
begin
ignoraErro := true;
delete (lido, length(lido), 1);
lido := trim (lido);
end;

if maiuscAnsi (copy (lido, 1, 5)) = 'CRIA ' then
op := 'C'
else
if maiuscAnsi (copy (lido, 1, 7)) = 'REMOVE ' then
op := 'R'
else
if maiuscAnsi (copy (lido, 1, 6)) = 'TROCA ' then
op := 'T'
else
exit;

while (lido <> '') and (lido [1] <> ' ') do delete (lido, 1, 1);
lido := trim (lido);
if not extraiValor (lido, nomeDir) then exit;
if lido <> '' then exit;

{$I-}
case op of
'C':  mkdir (nomeDir);
'R':  rmdir (nomeDir);
'T':  chdir (nomeDir);
end;
{$I+}

if (ioresult <> 0) and (not ignoraErro) then
begin
sintWriteln (ERRO_DIR + nomeDir);
exit;
end;

processaDir := true;
end;

{--------------------------------------------------------}
{                  Comando Retorna
{--------------------------------------------------------}

function processaRetorna (lido: string): boolean;
begin
processaRetorna := false;
if lido <> '' then exit;

if topoRetorno = 0 then
begin
sintWriteln (STACK_UNDERFLOW);  {'Retorno sem chamada'}
exit;
end;

linhaAtual := pilhaRetorno[topoRetorno];
topoRetorno := topoRetorno -1;

processaRetorna := true;
end;

{--------------------------------------------------------}
{                    Comando IP
{--------------------------------------------------------}

function processaIP (lido: string): boolean;
var
endip: sockaddr_in;
local: boolean;
arqSel, v: char;
tam: integer;
begin
processaIP := false;
if lido = '' then exit;

if maiuscAnsi (copy (lido, 1, 6)) = 'LOCAL ' then
begin
local := true;
delete (lido, 1, 6);
end
else
if maiuscAnsi (copy (lido, 1, 7)) = 'REMOTO ' then
begin
local := false;
delete (lido, 1, 7);
end
else
exit;

lido := trim (lido);

if not extraiNumArq (lido, arqSel) then exit;
if not extraiVariavel (lido, v) then exit;

with arquivo [arqSel] do
begin
if soquete < 0 then exit;

tam := sizeof (sockaddr_in);
if local then
getSockName (soquete, endip, tam)
else
getpeername(soquete, endip, tam);

varScript[v] := strPas (inet_ntoa (TInAddr(endip.sin_addr.S_addr)));
end;

processaIP := true;
end;

{--------------------------------------------------------}
{                    Comando MSAA
{--------------------------------------------------------}

function processaMSAA (lido: string): boolean;
var x, y, dx, dy, erro: integer;
valor: string;
v: char;
begin
processaMSAA := false;
if (maiuscAnsi (copy (lido, 1, 8))) = 'MONITORA' then
begin
delete (lido, 1, 8);
MSAAMonitora (true);
end
else
if (maiuscAnsi (copy (lido, 1, 3))) = 'FIM' then
begin
delete (lido, 1, 3);
MSAAMonitora (false);
end
else
if (maiuscAnsi (copy (lido, 1, 5))) = 'CHECA' then
begin
delete (lido, 1, 5);
if not extraiVariavel (lido, v) then exit;
if MSAAPegaEvento then
varScript[v] := '1'
else
varScript[v] := '0';
end
else
if (maiuscAnsi (copy (lido, 1, 7))) = 'CAPTURA' then
begin
delete (lido, 1, 7);
if not extraiValor (lido, valor) then exit;
val (valor, x, erro);
if erro <> 0 then exit;
if not extraiValor (lido, valor) then exit;
val (valor, y, erro);
if erro <> 0 then exit;
MSAAPegaPonto (x, y);
end
else
if (maiuscAnsi (copy (lido, 1, 4))) = 'AREA' then
begin
delete (lido, 1, 4);
MSAACoord (x, y, dx, dy);
if not extraiVariavel (lido, v) then exit;
str (x, varScript[v]);
if not extraiVariavel (lido, v) then exit;
str (y, varScript[v]);
if not extraiVariavel (lido, v) then exit;
str (dx, varScript[v]);
if not extraiVariavel (lido, v) then exit;
str (dy, varScript[v]);
end
else
if (maiuscAnsi (copy (lido, 1, 4))) = 'NOME' then
begin
delete (lido, 1, 4);
if not extraiVariavel (lido, v) then exit;
varScript[v] := MSAANome;
end
else
if ((maiuscAnsi (copy (lido, 1, 6))) = 'CODIGO') or
((maiuscAnsi (copy (lido, 1, 6))) = 'CDIGO') then
begin
delete (lido, 1, 6);
if not extraiVariavel (lido, v) then exit;
str (MSAACodTipo, varScript[v]);
end
else
if ((maiuscAnsi (copy (lido, 1, 4))) = 'TIPO') then
begin
delete (lido, 1, 4);
if not extraiVariavel (lido, v) then exit;
varScript[v] := MSAATipo;
end
else
if ((maiuscAnsi (copy (lido, 1, 6))) = 'ESTADO') then
begin
delete (lido, 1, 6);
if not extraiVariavel (lido, v) then exit;
varScript[v] := MSAAStatus;
end
else
if ((maiuscAnsi (copy (lido, 1, 5))) = 'VALOR') then
begin
delete (lido, 1, 5);
if not extraiVariavel (lido, v) then exit;
varScript[v] := MSAAValor;
end
else
exit;

processaMSAA := true;
end;

{--------------------------------------------------------}
{                    Comando MENU
{--------------------------------------------------------}

function processaMenu (lido: string): boolean;
var xmin, ymin, xmax, ymax, erro: integer;
valor, s: string;
v1, v2, v3: char;
c1, c2: char;
n: integer;
selec: boolean;
begin
processaMenu := false;
if (maiuscAnsi (copy (lido, 1, 4))) = 'CRIA' then
begin
delete (lido, 1, 4);
if not extraiValor (lido, valor) then exit;
val (valor, xmin, erro);
if erro <> 0 then exit;
if not extraiValor (lido, valor) then exit;
val (valor, ymin, erro);
if erro <> 0 then exit;
if not extraiValor (lido, valor) then exit;
val (valor, xmax, erro);
if erro <> 0 then exit;
if not extraiValor (lido, valor) then exit;
val (valor, ymax, erro);
if erro <> 0 then exit;
folheiaCria (xmin, ymin, xmax, ymax);
itemInic := 1;
end
else
if (maiuscAnsi (copy (lido, 1, 8))) = 'ADICIONA' then
begin
delete (lido, 1, 8);
if not extraiValor (lido, valor) then exit;
folheiaAdiciona(valor);
end
else
if (maiuscAnsi (copy (lido, 1, 7))) = 'TERMINA' then
begin
delete (lido, 1, 7);
folheiaLimpa;
folheiaDestroi;
end
else
if (maiuscAnsi (copy (lido, 1, 7))) = 'EXECUTA' then
begin
delete (lido, 1, 7);
if not extraiVariavel (lido, v1) then exit;  // nmero do item
if not extraiVariavel (lido, v2) then exit;  // letra acionada
if not extraiVariavel (lido, v3) then exit;  // item escolhido
repeat
try
itemInic := strToInt (trim(varScript[v1]));
except end;
if itemInic <= 0 then
itemInic := 1;
folheiaExecuta(itemInic, n, c1, c2, true);
until (c1 <> #0) or (c2 in [F1..F12]);

str (n, varScript[v1]);

if c1 >= ' ' then
varScript[v2] := c1
else
if (c1 = #0) and (c2 in [F1..F12]) then
varScript[v2] := '#0#' + intToStr (ord(c2) - ord(F1) + 59)
else
begin
str (ord(c1), s);
varScript[v2] := '#' + s;
end;
folheiaObtemItem(n, varScript[v3], selec);
end
else
exit;

if lido <> '' then exit;
processaMenu := true;
end;

{--------------------------------------------------------}
{                    Comando IMAGEM
{--------------------------------------------------------}

function processaImagem (lido: string): boolean;
var
nomeArq: string;
x, y, erro: integer;
ignoraErro: boolean;
s: string;
begin
processaImagem := false;
if lido = '' then
begin
closeBMP;
processaImagem := true;
exit;
end;

ignoraErro := false;
if lido[length(lido)] = '&' then
begin
ignoraErro := true;
delete (lido, 1, length (lido));
lido := trim (lido);
end;

if not extraiValor (lido, nomeArq) then exit;
if lido <> '' then
begin
if not extraiValor (lido, s) then exit;
val (s, x, erro);
if erro <> 0 then exit;
if not extraiValor (lido, s) then exit;
val (s, y, erro);
if erro <> 0 then exit;

if lido <> '' then exit;
end
else
begin
x := 0;
y := 0;
end;

closeBMP;
if trim (nomeArq) <> '' then
begin
if (ansiUpperCase (copy (nomeArq, length (nomeArq)-3, 4)) = '.JPG') or
(ansiUpperCase (copy (nomeArq, length (nomeArq)-5, 5)) = '.JPEG') then
begin
if FileExists(nomeArq) then
begin
CopyJpegToBmp (nomeArq, 'c:\$$$.bmp');
nomeArq := 'c:\$$$.bmp';
end;
end;
if not openBMP (nomeArq) then
begin
if not ignoraErro then exit;
end
else
paintBMP (x, y);
end;

processaImagem := true;
if nomeArq = 'c:\$$$.bmp' then
DeleteFile('c:\$$$.bmp');
end;

{--------------------------------------------------------}
{                    Comando SENSOR
{--------------------------------------------------------}

type
TInp32 = function (PortAddress: word): byte;   stdcall;
TOut32 = procedure (PortAddress: word; data: byte);   stdcall;

const
basepr = $378;    // 378 ou 278

var
Inp32: TInp32;
Out32: TOut32;
HInpOut32: THandle;
mascChaves: byte;
vetChaves: array[1..32] of boolean;

procedure inicChaves;
begin
if hInpOut32 <> 0 then exit;

hInpOut32 := LoadLibrary ('inpout32.dll');
if hInpOut32 = 0 then
begin
beep;
sintWriteln ('inpout32.dll no disponvel.');
exit;
end;

inp32 := GetProcAddress(HInpOut32, 'Inp32');
out32 := GetProcAddress(HInpOut32, 'Out32');

out32 ($37A, $ff);
sleep (1);
out32 ($378, 1);
sleep (1);
mascChaves := inp32 ($379);
end;

procedure obtemChaves;
var x, i: integer;
begin
if hInpOut32 = 0 then exit;

for i := 0 to 7 do
begin
out32 ($37A, $ff);
sleep (1);
out32 ($378, not ($80 shr i));
sleep (1);
x := inp32 ($379) xor mascChaves;

vetChaves[i*4+1] := (x and $80) <> 0;
vetChaves[i*4+2] := (x and $40) <> 0;
vetChaves[i*4+3] := (x and $20) <> 0;
vetChaves[i*4+4] := (x and $10) <> 0;
end;
end;


function processaSensor (lido: string): boolean;
var
v: char;
n: integer;
begin
processaSensor := false;
if not sensorAtivo then inicChaves;

if not extraiVariavel (lido, v) then exit;
obtemChaves;

varScript [v] := '0';
for n := 1 to 32 do
if vetChaves[n]  then
begin
varScript [v] := intToStr (n);
exit;
end;
end;

{--------------------------------------------------------}
{             executa um comando do script
{--------------------------------------------------------}

function executaComando (cmd, lido: string): boolean;
begin
if cmd = '' then
begin
executaComando := false;
exit;
end;

lido := trim (lido);
if debug then
sintWriteln (cmd + ' ' + lido);

cmd := maiuscAnsi (cmd);
if cmd='MIDI' then executaComando:=processaMIDI(lido)
else

if cmd = 'DEBUG'     then executaComando := processaDebug (lido)
else
if cmd = 'SEJA'      then executaComando := processaSeja (lido)
else
if cmd = 'TELA'      then executaComando := processaTela (lido)
else
if cmd = 'COR'       then executaComando := processaCor (lido)
else
if cmd = 'FUNDO'     then executaComando := processaFundo (lido)
else
if cmd = 'ABRE'      then executaComando := processaAbre (lido)
else
if cmd = 'FECHA'     then executaComando := processaFecha (lido)
else
if cmd = 'INTERNET'  then executaComando := processaInternet (lido)
else
if cmd = 'CONECTA'   then executaComando := processaConecta (lido)
else
if cmd = 'ATIVASSL'   then executaComando := processaAtivaSsl (lido)
else
if cmd = 'SERVE'     then executaComando := processaServe (lido)
else
if cmd = 'OBSERVA'   then executaComando := processaObserva (lido)
else
if cmd = 'ESCREVE'   then executaComando := processaEscreve (lido)
else
if cmd = 'BIPA'      then executaComando := processaBipa (lido)
else
if cmd = 'SOMA'      then executaComando := processaSoma (lido)
else
if cmd = 'SUBTRAI'   then executaComando := processaContas (lido, '-')
else
if cmd = 'MULTIPLICA' then executaComando := processaContas (lido, '*')
else
if cmd = 'DIVIDE'    then executaComando := processaContas (lido, '/')
else
if cmd = 'CONCATENA' then executaComando := processaConcatena (lido)
else
if cmd = 'COPIA'     then executaComando := processaCopia (lido)
else
if cmd = 'SOLETRA'     then executaComando := processaSoletra (lido)
else
if cmd = 'LISTA'     then executaComando := processaLista (lido)
else
if cmd = 'FALAHORA'     then executaComando := processaFalaHora (lido)
else
if (cmd = 'TITULO') or (cmd = 'TTULO')    then executaComando := processaTitulo (lido)
else
if cmd = 'DELETA'     then executaComando := processaDeleta (lido)
else
if cmd = 'SUBSTITUI' then executaComando := processaSubstitui (lido)
else
if cmd = 'TOCA'      then executaComando := processaToca (lido)
else
if cmd = 'FALA'      then executaComando := processaFala (lido)
else
if cmd = 'MCI'       then executaComando := processaMci (lido)
else
if (cmd = 'L') or
(cmd = 'LE')      then executaComando := processaLe (lido)
else
if cmd = 'CHECA'     then executaComando := processaCheca (lido)
else
if cmd = 'REMOVE'    then executaComando := processaRemove (lido)
else
if cmd = 'RENOMEIA'  then executaComando := processaRenomeia (lido)
else
if cmd = 'REPLICA'   then executaComando := processaReplica (lido)
else
if cmd = 'CMD'       then executaComando := processaCmd (lido)
else
if cmd = 'ESPERA'    then executaComando := processaEspera (lido)
else
if cmd = 'DIGITA'    then executaComando := processaDigita (lido)
else
if cmd = 'ACIONA'    then executaComando := processaAciona (lido)
else
if cmd = 'CLICA'     then executaComando := processaClica (lido)
else
if cmd = 'CAPTURA'   then executaComando := processaCaptura (lido)
else
if cmd = 'TRANSFERE' then executaComando := processaTransfere (lido)
else
if cmd = 'JANELA'    then executaComando := processaJanela (lido)
else
if cmd = 'DESVIA'    then executaComando := processaDesvia (lido)
else
if cmd = 'SE'        then executaComando := processaSe (lido)
else
if (cmd = 'SENAO') or (cmd = 'SENO')
then executaComando := processaSenao (lido)
else
if cmd = 'ENQUANTO'  then executaComando := processaEnquanto (lido)
else
if cmd = 'REPETE'    then executaComando := processaRepete (lido, false)
else
if cmd = 'FIM'       then executaComando := processaFimBloco (lido)
else
if cmd = 'EXECUTA'   then executaComando := processaExecuta (lido)
else
if cmd = 'EXISTEPROG'   then executaComando := processaExisteProg (lido)
else
if cmd = 'DIR'       then executaComando := processaDir (lido)
else
if cmd = 'BUSCA'     then executaComando := processaBusca (lido)
else
if cmd = 'TERMINA'   then executaComando := processaTermina (lido)
else
if cmd = 'CHAMA'     then executaComando := processaChama (lido)
else
if cmd = 'RETORNA'   then executaComando := processaRetorna (lido)
else
if cmd = 'RANDOMIZA' then executaComando := processaRandomiza (lido)
else
if cmd = 'IP'        then executaComando := processaIp (lido)
else
if cmd = 'MSAA'      then executaComando := processaMSAA (lido)
else
if cmd = 'MENU'      then executaComando := processaMENU (lido)
else
if cmd = 'IMAGEM'    then executaComando := processaImagem (lido)
else
if cmd = 'SENSOR'      then executaComando := processaSensor (lido)
    else
if cmd = 'ANSIPARAUTF8' then executacomando := processaansiparautf8(lido)
else
    if cmd = 'UTF8PARAANSI' then executacomando := processautf8paraansi(lido)
else
    if (cmd = 'HTTP') then executacomando := processahttp(lido)
else
    if cmd = 'TRAZDAREDE' then executacomando := processatrazdarede(lido)
    else
    if cmd = 'MENSAGEM' then executacomando := processamensagem(lido)
else
    if cmd = 'CODBASE64' then executacomando := processacodbase64(lido)
else
    if cmd = 'REMOVEQUOTED' then executacomando := processaremovequoted(lido)
else
    if cmd = 'ADQUOTED' then executacomando := processaadquoted(lido)
else
    if cmd = 'CODARQBASE64' then executacomando := processacodarqbase64(lido)
else
    if cmd = 'DECODARQBASE64' then executacomando := processadecodarqbase64(lido)
else
    if cmd = 'DECODBASE64' then executacomando := processadecodbase64(lido)
else
begin
executaComando := false;
sintWriteln (COMANDO_INVALIDO + cmd);   {'Comando invlido: '}
end;
end;

{--------------------------------------------------------}
{                executa uma linha
{--------------------------------------------------------}

function execCmdScript (lido: string; procExterno: boolean): boolean;
var c: char;
begin
execCmdScript := true;
lido := trim (lido);
if (lido = '') or (lido[1] = '*') or (lido[1] = '@') then
exit;

cmd := '';
repeat
c := upcase (lido [1]);
delete (lido, 1, 1);
if c <> ' ' then
cmd := cmd + upcase (c);
until (c = ' ') or (lido = '');

if procExterno and
((cmd = 'REPETE') or (cmd = 'ENQUANTO') or
(cmd = 'SENAO') or (cmd = 'SENO') or
(cmd = 'FIM')) then
execCmdScript := false    {esses no so vlidos como imediatos}
else
begin
erroProc := not executaComando (cmd, lido);
execCmdScript := not erroProc;
end;
end;

{--------------------------------------------------------}
{      executa uma linha em processamento externo
{--------------------------------------------------------}

function cmdScript (lido: string): boolean;
begin
cmdScript := execCmdScript (lido, true);
end;

{--------------------------------------------------------}
{                executa todo script
{--------------------------------------------------------}

function executaScript (var ultLinhaProc: integer): integer;
var
lido: string;

begin
linhaAtual := 1;
erroProc := false;
fimScript := false;
cmd := '';
topoRetorno := 0;
statusUltIO := 0;

while (linhaAtual <= nLinhasScript) and (not fimScript) and
(not erroProc) do
begin
lido := script[linhaAtual];
execCmdScript (lido, false);
if (not fimScript) and (not erroProc) then
linhaAtual := linhaAtual + 1;
end;

if erroProc then
executaScript := SCR_ERROEXEC
else
executaScript := SCR_OK;

liberaScript;
ultLinhaProc := linhaAtual;
end;

{--------------------------------------------------------}
{                    processamento
{--------------------------------------------------------}
procedure processa;
var retorno, ultLinProc: integer;
begin
    retorno := executaScript ( ultLinProc);
    case retorno of
        SCR_OK:
            if not fimScriptMudo then
                mensagem ('SCFIM', 1);   {'Fim do script'}
        SCR_ERROEXEC:
            begin
                showWindow (crtWindow, SW_RESTORE);
                mensagem ('SCERREXE', 0);   {'Erro de execuo na linha '}
                sintWriteint (ultLinProc);
                writeln;
                readln;
            end;
        SCR_SEMARQUIVO:
            mensagem ('SCARQNAO', 1);   {'Arquivo inexistente'}
        SCR_ROTULOINVALIDO:
            mensagem ('SCERRROT', 1);   {''Este rtulo no existe !'}
    end;
end;
{--------------------------------------------------------}
{                      finalizao
{--------------------------------------------------------}
procedure finaliza;
begin
    CoUnInitialize;
    sintFim;
    doneWinCrt;
end;

{--------------------------------------------------------}
{              zera as variveis do script
{      Ateno: carregar e executar script no zeram,
{        isso s ocorre na inicializao do mdulo
{--------------------------------------------------------}

procedure zeraVarScript;
var c: char;
i: integer;
ano0, mes0, dia0: word;
hora0, minuto0, segundo0, cent0: word;
{$IFDEF VER150}
date_and_time: TDateTime;
{$ENDIF}

begin
linhaAtual := 1;
erroProc := false;
fimScript := false;
cmd := '';
topoRetorno := 0;
statusUltIO := 0;

nomeVarLonga.Clear;

for c := '0' to '9' do
arquivo[c].aberto := false;

for c := 'A' to chr(ord('Z') + 101) do
varScript[c] := '';

for i :=0 to 19 do
begin
if varLista[i] <> nil then
begin
zeraLista(varLista[i]);
varLista[i] := nil;
end;
end;
fimScript := true;
delay (1);   { estabilizador de processamento virtual }

{$IFDEF VER150}
date_and_time := now;
decodeDate (date_and_time, ano0, mes0, dia0);
decodeTime (date_and_time, hora0, minuto0, segundo0, cent0);
semana0 := dayOfTheWeek (date_and_time);
{$ELSE}
getDate(ano0, mes0, dia0, semana0);
gettime (hora0, minuto0, segundo0, cent0);
{$ENDIF}
tempo0 := ((hora0*60+minuto0)*60+segundo0)*100+cent0;
end;

{--------------------------------------------------------}
{                obtm uma varivel longa
{--------------------------------------------------------}

function obtemVarLongaScript (nome: string): string;
var n: integer;
begin
n := nomeVarLonga.indexOf(nome);
result := varScript[chr (n+1 + ord('Z'))];
end;

{--------------------------------------------------------}
{                altera uma varivel longa
{--------------------------------------------------------}

procedure alteraVarLongaScript (nome, valor: string);
var n: integer;
begin
n := nomeVarLonga.indexOf(nome);
if n < 0 then
begin
nomeVarLonga.Add(nome);
n := nomeVarLonga.count-1;
end;
varScript[chr (n+1 + ord('Z'))] := valor;
end;

function getflags():string;
var
flags:string;
begin
flags:='';
if (GetKeyState(16)<0) then flags:=flags+'1' else flags:=flags+'0';
if (GetKeyState(17)<0) then flags:=flags+'1' else flags:=flags+'0';
if (GetKeyState(18)<0) then flags:=flags+'1' else flags:=flags+'0';
getflags:=flags;
end; {function getflags}

begin
nomeVarLonga := TStringList.Create;
zeraVarScript;
MIDIAberto := false;
end.
